package com.uoc.christian.bttroute.CambioContrasena;

import android.content.Context;

import com.uoc.christian.bttroute.R;

/**
 * Created by Christian on 17/10/2017.
 */

public class CambioContrasenaPresenterImplement implements CambioContrasenaPresenter {

    Context context;
    CambioContrasenaView cambioContrasenaView;

    public CambioContrasenaPresenterImplement(CambioContrasenaView cambioContrasenaView, Context context){
        this.cambioContrasenaView = cambioContrasenaView;
        this.context = context;
        onCreate(this.cambioContrasenaView, this.context);
    }

    @Override
    public void onCreate(CambioContrasenaView cambioContrasenaView, Context context) {
        this.cambioContrasenaView = cambioContrasenaView;
        this.context = context;
    }

    @Override
    public void onDestroy() {
        context = null;
        cambioContrasenaView = null;
    }

    /*
     * Comprobamos las contraseñas
     */
    @Override
    public Boolean comprobarCampos(String contrasenaActual, String contrasenaNueva, String contrasenaRepetida) {
        //Primero comprobamos que todas las contraseñas estén completadas
        if(!contrasenaActual.isEmpty() && !contrasenaNueva.isEmpty() && !contrasenaRepetida.isEmpty()){
            //Después comprobamos que la contraseña nueva y la repetida son iguales
            if(contrasenaNueva.equals(contrasenaRepetida)){
                return true;
            }else{
                cambioContrasenaView.mostrarToast(context.getResources().getString(R.string.cambioContrasena_mensaje_contrasenaNoSonIguales));
            }
        }else{
            cambioContrasenaView.mostrarToast(context.getResources().getString(R.string.cambioContrasena_mensaje_faltanDatos));
        }
        return false;
    }

    /*
     * Comprobamos que la contraseña actual introducida es igual a la contraseña registrada en el sistema
     */
    @Override
    public Boolean comprobarContrasenaActual(String contrasenaUser, String contrasenaActual) {
        if(contrasenaUser.equals(contrasenaActual)){
            return true;
        }
        return false;
    }
}
