package com.uoc.christian.bttroute.DetalleRutaGrabada;

import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.location.Location;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import com.example.christian.myapplication.backend.inicioRutasApi.InicioRutasApi;
import com.example.christian.myapplication.backend.inicioRutasApi.model.InicioRutas;
import com.example.christian.myapplication.backend.rutaApi.RutaApi;
import com.example.christian.myapplication.backend.rutaApi.model.Ruta;
import com.google.android.gms.maps.model.LatLng;
import com.google.api.client.extensions.android.http.AndroidHttp;
import com.google.api.client.extensions.android.json.AndroidJsonFactory;
import com.squareup.picasso.Callback;
import com.squareup.picasso.Picasso;
import com.uoc.christian.bttroute.MapaAmpliado.MapaAmpliadoActivity;
import com.uoc.christian.bttroute.PantallaInicial.PantallaInicialActivity;
import com.uoc.christian.bttroute.R;

import org.osmdroid.util.GeoPoint;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import dataUtils.CheckConexionInternet;
import dataUtils.ConexionBackend;
import dataUtils.Constants;
import dataUtils.DatosRuta;
import dataUtils.ExportToGPXFile;
import dataUtils.PolyUtil;

import static dataUtils.ConexionBackend.url;

public class DetallaRutaGrabadaActivity extends AppCompatActivity implements DetalleRutaGrabadaView {

    @BindView(R.id.appbar)
    Toolbar appbar;
    @BindView(R.id.mapView)
    ImageView mapView;
    @BindView(R.id.textDatosRuta)
    TextView textDatosRuta;
    @BindView(R.id.textLblDistancia)
    TextView textLblDistancia;
    @BindView(R.id.textLblTiempo)
    TextView textLblTiempo;
    @BindView(R.id.textResultDistancia)
    TextView textResultDistancia;
    @BindView(R.id.textResultTiempo)
    TextView textResultTiempo;
    @BindView(R.id.textLblDifTecncia)
    TextView textLblDifTecncia;
    @BindView(R.id.textLblDifFisica)
    TextView textLblDifFisica;
    @BindView(R.id.textResultDifTecnica)
    TextView textResultDifTecnica;
    @BindView(R.id.textResultDifFisica)
    TextView textResultDifFisica;
    @BindView(R.id.textLblDesnivel)
    TextView textLblDesnivel;
    @BindView(R.id.textLblTipoRuta)
    TextView textLblTipoRuta;
    @BindView(R.id.textResultDesnivel)
    TextView textResultDesnivel;
    @BindView(R.id.textResultTipoRuta)
    TextView textResultTipoRuta;
    @BindView(R.id.textLblVelMaxima)
    TextView textLblVelMaxima;
    @BindView(R.id.textLblVelMedia)
    TextView textLblVelMedia;
    @BindView(R.id.textResultVelMaxima)
    TextView textResultVelMaxima;
    @BindView(R.id.textResultVelMedia)
    TextView textResultVelMedia;
    @BindView(R.id.textLblObservaciones)
    TextView textLblObservaciones;
    @BindView(R.id.textResultObservaciones)
    TextView textResultObservaciones;
    @BindView(R.id.progressbar)
    ProgressBar progressbar;
    @BindView(R.id.textResultDesnivelNegativo)
    TextView textResultDesnivelNegativo;
    @BindView(R.id.textResultDesnivelAcumulado)
    TextView textResultDesnivelAcumulado;
    @BindView(R.id.progressBar2)
    ProgressBar progressBar2;

    private DetalleRutaGrabadaPresenterImplement presenter;
    private DatosRuta datosRuta;
    private RutaApi servicio;
    private InicioRutasApi servicioInicioRutas;
    private String urlMapStatic = "";
    private boolean tenemosConexion = true;
    private boolean mapaCargado;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_detalla_ruta_grabada);
        ButterKnife.bind(this);
        Bundle bundle = getIntent().getExtras();
        datosRuta = (DatosRuta) bundle.getSerializable(Constants.datosRutaUsuario);
        setupPresenter();
        setupActionbar();
        cargarMapa();
        setDesnivelPositivo();
        setDesnivelAcumulado();
        setDesnivelNegativo();
        setDifFisicia();
        setDifTecnica();
        setDistancia();
        setObservaciones();
        setTiempo();
        setTipoRuta();
        setVelocidadMedia();
        setVelocidadMaxima();
    }

    @Override
    public void setupPresenter() {
        presenter = new DetalleRutaGrabadaPresenterImplement(this, datosRuta, getApplicationContext());
    }

    /*
     * Seteamos la barra actionbar
     */
    @Override
    public void setupActionbar() {
        appbar.setTitle(getString(R.string.app_name));
        appbar.setSubtitle(presenter.getTitulo());
        setSupportActionBar(appbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
    }

    /*
     * Acción exportar ruta. Llamamos a una clase que ejecuta la acción en background
     */
    @Override
    public void exportarRuta() {
        new exportarArchivo().execute();
    }

    /*
     * Acción para compartir la ruta. Llamamos a una clase que ejecuta la acción en background
     */
    @Override
    public void compartirRuta() {
        new actualizarCompartirRuta().execute(datosRuta);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()) {
            case R.id.menu_ruta_usuario_exportar:
                exportarRuta();
                return true;
            case R.id.menu_ruta_usuario_subir:
                compartirRuta();
                return true;
            case android.R.id.home:
                finish();
                return true;

        }

        return super.onOptionsItemSelected(item);
    }

    /*
     * Inflamos el menú en el actionbar
     */
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_detalle_ruta_usuario, menu);
        return true;
    }

    /*
     * Seteamos campo distancia
     */
    @Override
    public void setDistancia() {
        textResultDistancia.setText(presenter.getDistancia() + " m");
    }

    /*
     * Seteamos campo tiempo
     */
    @Override
    public void setTiempo() {
        textResultTiempo.setText(presenter.getTiempo());
    }

    /*
     * Seteamos campo desnivel
     */
    @Override
    public void setDesnivelPositivo() {
        textResultDesnivel.setText(presenter.getDesnivelPositivo() + " m");
    }

    @Override
    public void setDesnivelNegativo() {
        textResultDesnivelNegativo.setText(presenter.getDesnivelNegativo() + " m");
    }

    @Override
    public void setDesnivelAcumulado() {
        textResultDesnivelAcumulado.setText(presenter.getDesnivelAcumulado() + " m");
    }

    /*
     * Seteamos campo dificultad física
     */
    @Override
    public void setDifFisicia() {
        textResultDifFisica.setText(presenter.getDifFisica());
    }

    /*
     * Seteamos campo dificultad técnica
     */
    @Override
    public void setDifTecnica() {
        textResultDifTecnica.setText(presenter.getDifTecnica());
    }

    /*
     * Seteamos campo tipo ruta
     */
    @Override
    public void setTipoRuta() {
        textResultTipoRuta.setText(presenter.getTipoRuta());
    }

    /*
     * Seteamos campo observaciones
     */
    @Override
    public void setObservaciones() {
        if (presenter.getObservaciones() == null || presenter.getObservaciones().equals("")) {
            textLblObservaciones.setVisibility(View.GONE);
            textResultObservaciones.setVisibility(View.GONE);
        } else {
            textLblObservaciones.setVisibility(View.VISIBLE);
            textResultObservaciones.setVisibility(View.VISIBLE);
            textResultObservaciones.setText(presenter.getObservaciones());
        }
    }

    /*
     * Seteamos campo velocidad máxima
     */
    @Override
    public void setVelocidadMaxima() {
        textResultVelMaxima.setText(presenter.getVelocidadMaxima() + " Km/h");
    }

    /*
     * Seteamos campo velocidad media
     */
    @Override
    public void setVelocidadMedia() {
        textResultVelMedia.setText(presenter.getVelocidadMedia() + " Km/h");
    }

    /*
     * Mostramos un toast con el mensaje recibido
     */
    @Override
    public void mostrarToast(String mensaje) {
        Toast.makeText(getApplicationContext(), mensaje, Toast.LENGTH_LONG).show();
    }

    /*
     * Mostramos o ocultamos la barra de progreso
     */
    @Override
    public void mostrarProgressbar(boolean mostrar) {
        if (mostrar) {
            progressbar.setVisibility(View.VISIBLE);
        } else {
            progressbar.setVisibility(View.INVISIBLE);
        }
    }

    /*
     * Accedemos a la pantalla de ampliación de mapa para que el usuario pueda obtener
     * mayor detalle
     */
    @OnClick(R.id.mapView)
    @Override
    public void handleAmpliarMapa() {
        if(mapaCargado) {
            Intent intent = new Intent(DetallaRutaGrabadaActivity.this, MapaAmpliadoActivity.class);
            intent.putExtra(Constants.geoPointsCodificados, datosRuta.getGeoPointsCodificados());
            intent.putExtra(Constants.tituloRuta, datosRuta.getTituloRuta());
            startActivity(intent);
        }else{
            mostrarToast(getString(R.string.mapaAmplidado_error));
        }
    }

    /*
     * Cargamos el mapa estático
     */
    @Override
    public void cargarMapa() {
        urlMapStatic = "https://www.mapquestapi.com/staticmap/v5/map?key=" + Constants.APIKeyMapQuest + "&shape=cmp|enc:" + datosRuta.getGeoPointsCodificados() + "&size=500,300";
        Picasso.with(getApplicationContext()).cancelRequest(mapView);
        Picasso.with(getApplicationContext())
                .load(urlMapStatic)
                .into(mapView, new Callback() {
                    @Override
                    public void onSuccess() {
                        if (progressBar2 != null && progressBar2.getVisibility() == View.VISIBLE) {
                            progressBar2.setVisibility(View.GONE);
                        }
                        mapaCargado = true;
                    }

                    @Override
                    public void onError() {
                        if (progressBar2 != null && progressBar2.getVisibility() == View.VISIBLE) {
                            progressBar2.setVisibility(View.GONE);
                        }
                        mapaCargado = false;
                    }
                });
    }

    /*
     * Clase para permitir que otros usuario puedan consultar la ruta
     */
    private class actualizarCompartirRuta extends AsyncTask<DatosRuta, Void, Ruta> {

        Ruta rutaActualizada = null;
        Boolean rutaCompartida = false;

        @Override
        protected void onPreExecute() {
            mostrarProgressbar(true);
        }

        @Override
        protected Ruta doInBackground(DatosRuta... datosRutas) {
            try {
                //Comprobamos si tenemos conexión a internet
                if (CheckConexionInternet.tenemosConexion(getApplicationContext())) {
                    //Iniciamos el servicio de RutaApi
                    if (servicio == null) {
                        RutaApi.Builder builder = new RutaApi.Builder(AndroidHttp.newCompatibleTransport(), new AndroidJsonFactory(), null)
                                .setRootUrl(url);

                        servicio = builder.build();
                    }

                    //Iniciamos el servicio de InicioRutas
                    if (servicioInicioRutas == null) {
                        InicioRutasApi.Builder builder = new InicioRutasApi.Builder(AndroidHttp.newCompatibleTransport(), new AndroidJsonFactory(), null)
                                .setRootUrl(url);

                        servicioInicioRutas = builder.build();
                    }

                    try {
                        //Antes comprobamos si la ruta no está todavia compartida
                        if (!datosRuta.getCompartida()) {
                            if (datosRuta.getIdRutaOrigen() == null || datosRuta.getIdRutaOrigen() == "" || datosRuta.getIdRutaOrigen() == "null" || datosRuta.getIdRutaOrigen().isEmpty()) {

                                tenemosConexion = true;

                                Ruta ruta = new Ruta();
                                ruta.setId(datosRutas[0].getIdRuta());
                                ruta.setGeoPointsCodificados(datosRutas[0].getGeoPointsCodificados());

                                rutaActualizada = servicio.update(ruta).execute();
                                String geopoints = rutaActualizada.getGeoPointsCodificados();

                                List<LatLng> latLng = PolyUtil.decode(geopoints);

                                InicioRutas i = new InicioRutas();
                                i.setIdRuta(ruta.getId());
                                i.setLatInicial(latLng.get(0).latitude);
                                i.setLongInicial(latLng.get(0).longitude);

                                //insertamos las coordenadas de inicio de la ruta.
                                servicioInicioRutas.insert(i).execute();

                                datosRuta.setCompartida(true);
                                //Este parámetro lo indicamos para que al volver a la pantalla de "mis rutas"
                                //se vuelva a cargar la lista y tener todos los datos actualizados.
                                Constants.volverActualizar = true;
                            } else {
                                rutaCompartida = false;
                            }
                        } else {
                            rutaCompartida = true;
                        }
                    } catch (IOException e) {
                        e.printStackTrace();
                    }

                } else {
                    tenemosConexion = false;
                }
            } catch (MalformedURLException e) {
                e.printStackTrace();
            }
            return rutaActualizada;
        }

        @Override
        protected void onPostExecute(Ruta ruta) {
            mostrarProgressbar(false);

            if (ruta != null) {
                mostrarToast(getString(R.string.detalleRuta_usuario_compartida));
                Intent intent = new Intent(DetallaRutaGrabadaActivity.this, PantallaInicialActivity.class);
                setResult(RESULT_OK, intent);
                finish();
            } else {
                if (tenemosConexion) {
                    if (rutaCompartida) {
                        mostrarToast(getString(R.string.detalleRuta_usuario_yaCompartida));
                    } else {
                        mostrarToast(getString(R.string.detalleRuta_usuario_rutaYaExistente));
                    }
                } else {
                    mostrarToast(getString(R.string.sinConexion));
                }
            }
        }
    }

    /*
     * Clase para exportar una ruta a archivo GPX
     */
    private class exportarArchivo extends AsyncTask<Void, Void, Boolean> {

        boolean creado = false;

        @Override
        protected void onPreExecute() {
            mostrarProgressbar(true);
        }

        @Override
        protected Boolean doInBackground(Void... voids) {

            List<Location> locationList = new ArrayList<>();
            File file = new File(Environment.getExternalStorageDirectory(), Constants.carpetaArchivos + "/" + datosRuta.getTituloRuta() + ".gpx");

            if (!datosRuta.getGeoPointsCodificados().isEmpty()) {
                for (GeoPoint g : presenter.decodeGeopoints(datosRuta.getGeoPointsCodificados())) {
                    Location location = new Location("Location");
                    location.setLatitude(g.getLatitude());
                    location.setLongitude(g.getLongitude());
                    location.setLatitude(g.getLatitude());
                    locationList.add(location);
                }
            }

            //Exportamos el mapa
            creado = ExportToGPXFile.crearGPXFile(file, datosRuta.getTituloRuta(), locationList, datosRuta.getIdRuta(), datosRuta.getIdUsuario());

            return creado;
        }

        @Override
        protected void onPostExecute(Boolean result) {
            mostrarProgressbar(false);
            if (result) {
                mostrarToast(getString(R.string.detalleRuta_usuario_exportarOK));
            } else {
                mostrarToast(getString(R.string.detalleRuta_usuario_exportarKO));
            }
        }
    }
}
