package com.uoc.christian.bttroute.DetalleRutaGrabada;

import android.content.Context;

import com.example.christian.myapplication.backend.dificultadFisicaApi.model.DificultadFisica;
import com.example.christian.myapplication.backend.dificultadTecnicaApi.model.DificultadTecnica;
import com.example.christian.myapplication.backend.tipoRutaApi.model.TipoRuta;
import com.google.android.gms.maps.model.LatLng;
import dataUtils.DatosFiltros;
import dataUtils.DatosRuta;
import dataUtils.PolyUtil;

import org.osmdroid.util.GeoPoint;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by christian on 1/11/17.
 */

public class DetalleRutaGrabadaPresenterImplement implements DetalleRutaGrabadaPresenter {

    private DetalleRutaGrabadaView detalleRutaGrabadaView;
    private DatosRuta datosRuta;
    private Context context;
    List<GeoPoint> lista = new ArrayList<>();

    public DetalleRutaGrabadaPresenterImplement(DetalleRutaGrabadaView detalleRutaGrabadaView, DatosRuta datosRuta, Context context){
        this.detalleRutaGrabadaView = detalleRutaGrabadaView;
        this.datosRuta = datosRuta;
        this.context = context;
        onCreate(detalleRutaGrabadaView, datosRuta, context);
    }

    @Override
    public void onCreate(DetalleRutaGrabadaView detalleRutaGrabadaView, DatosRuta datosRuta, Context context) {
        this.detalleRutaGrabadaView = detalleRutaGrabadaView;
        this.datosRuta = datosRuta;
        this.context = context;
    }

    @Override
    public void onDestroy() {
        detalleRutaGrabadaView = null;
        datosRuta = null;
        context = null;
    }

    @Override
    public String getDistancia() {
        return String.valueOf(datosRuta.getDistancia());
    }

    @Override
    public String getTiempo() {
        return datosRuta.getTiempo();
    }

    @Override
    public String getDesnivelPositivo() {
        return String.valueOf(datosRuta.getDesnivelPositivo());
    }

    @Override
    public String getDesnivelNegativo() {
        return String.valueOf(datosRuta.getDesnivelNegativo());
    }

    @Override
    public String getDesnivelAcumulado() {
        return String.valueOf(datosRuta.getDesnivelAcumulado());
    }

    @Override
    public String getDifFisica() {
        String descripcion="";
        for(DificultadFisica df: DatosFiltros.listaDificultadFisica){
            if(df.getId().toString().equals(datosRuta.getIdDificultadFisica().toString())){
                descripcion = df.getDescripcion();
            }
        }
        return descripcion;
    }

    @Override
    public String getDifTecnica() {
        String descripcion="";
        for(DificultadTecnica dt: DatosFiltros.listaDificultadTecnica){
            if(dt.getId().toString().equals(datosRuta.getIdDificultadTecnica().toString())){
                descripcion = dt.getDescripcion();
            }
        }
        return descripcion;
    }

    @Override
    public String getTipoRuta() {
        String descripcion="";
        for(TipoRuta tr: DatosFiltros.listaTipoRuta){
            if(tr.getId().toString().equals(datosRuta.getIdTipoRuta().toString())){
                descripcion = tr.getDescripcion();
            }
        }
        return descripcion;
    }

    @Override
    public String getObservaciones() {
        return datosRuta.getObservaciones();
    }

    @Override
    public String getVelocidadMaxima() {
        return String.valueOf(datosRuta.getVelocidadMaxima());
    }

    @Override
    public String getVelocidadMedia() {
        return String.valueOf(datosRuta.getVelocidadMedia());
    }

    @Override
    public String getTitulo() {
        return datosRuta.getTituloRuta();
    }

    @Override
    public List<GeoPoint> decodeGeopoints(String geoPointsCodificados) {
        if(!geoPointsCodificados.isEmpty()){
            List<LatLng> listaAux = PolyUtil.decode(geoPointsCodificados);

            for(int i=0;i<listaAux.size();i++){
                GeoPoint geoPoint = new GeoPoint(listaAux.get(i).latitude, listaAux.get(i).longitude);
                lista.add(geoPoint);
            }

        }
        return lista;
    }
}
