package com.uoc.christian.bttroute.DetalleRutaServidor;

import android.content.Intent;
import android.location.Location;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.example.christian.myapplication.backend.rutaApi.RutaApi;
import com.example.christian.myapplication.backend.rutaApi.model.Ruta;
import com.google.api.client.extensions.android.http.AndroidHttp;
import com.google.api.client.extensions.android.json.AndroidJsonFactory;
import com.squareup.picasso.Callback;
import com.squareup.picasso.Picasso;
import com.uoc.christian.bttroute.DetalleRutaServidor.Adapter.OnItemClickListener;
import com.uoc.christian.bttroute.DetalleRutaServidor.Adapter.RutasServidorAdapter;
import com.uoc.christian.bttroute.MapaAmpliado.MapaAmpliadoActivity;
import com.uoc.christian.bttroute.R;

import org.osmdroid.util.GeoPoint;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import dataUtils.ConexionBackend;
import dataUtils.Constants;
import dataUtils.DatosRuta;
import dataUtils.ExportToGPXFile;

public class DetalleRutaServidorActivity extends AppCompatActivity implements DetalleRutaServidorView, OnItemClickListener {

    @BindView(R.id.appbar)
    Toolbar appbar;
    @BindView(R.id.mapView)
    ImageView mapView;
    @BindView(R.id.textDatosRuta)
    TextView textDatosRuta;
    @BindView(R.id.imgDistancia)
    ImageView imgDistancia;
    @BindView(R.id.textLblDistancia)
    TextView textLblDistancia;
    @BindView(R.id.imgTiempo)
    ImageView imgTiempo;
    @BindView(R.id.textLblTiempo)
    TextView textLblTiempo;
    @BindView(R.id.textResultDistancia)
    TextView textResultDistancia;
    @BindView(R.id.textResultTiempo)
    TextView textResultTiempo;
    @BindView(R.id.imgDifTecnica)
    ImageView imgDifTecnica;
    @BindView(R.id.textLblDifTecncia)
    TextView textLblDifTecncia;
    @BindView(R.id.imgDifFisica)
    ImageView imgDifFisica;
    @BindView(R.id.textLblDifFisica)
    TextView textLblDifFisica;
    @BindView(R.id.textResultDifTecnica)
    TextView textResultDifTecnica;
    @BindView(R.id.textResultDifFisica)
    TextView textResultDifFisica;
    @BindView(R.id.imgDesnivel)
    ImageView imgDesnivel;
    @BindView(R.id.textLblDesnivel)
    TextView textLblDesnivel;
    @BindView(R.id.imgTipoRuta)
    ImageView imgTipoRuta;
    @BindView(R.id.textLblTipoRuta)
    TextView textLblTipoRuta;
    @BindView(R.id.textResultDesnivel)
    TextView textResultDesnivel;
    @BindView(R.id.textLblObservaciones)
    TextView textLblObservaciones;
    @BindView(R.id.textResultObservaciones)
    TextView textResultObservaciones;
    @BindView(R.id.textLblRutasProximas)
    TextView textLblRutasProximas;
    @BindView(R.id.listaRutasProximas)
    RecyclerView listaRutasProximas;
    @BindView(R.id.textResultTipoRuta)
    TextView textResultTipoRuta;
    @BindView(R.id.progressbar)
    ProgressBar progressbar;
    @BindView(R.id.progressbar2)
    ProgressBar progressbar2;
    @BindView(R.id.textSinResultados)
    TextView textSinResultados;
    @BindView(R.id.textResultDesnivelNegativo)
    TextView textResultDesnivelNegativo;
    @BindView(R.id.textResultadoDesnivelAcumulado)
    TextView textResultadoDesnivelAcumulado;
    @BindView(R.id.layoutDatos)
    RelativeLayout layoutDatos;
    @BindView(R.id.layoutRutasProximas)
    RelativeLayout layoutRutasProximas;
    @BindView(R.id.progressBar2)
    ProgressBar progressBar2;

    private DetalleRutaServidorPresenterImplement presenter;
    private DatosRuta datosRuta;
    private String urlMapStatic = "";
    private RutaApi servicio = null;
    private RutasServidorAdapter adapter = null;
    private boolean refreshSwipe = false;
    private boolean mapaCargado;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_detalle_ruta_servidor);
        ButterKnife.bind(this);

        Bundle bundle = getIntent().getExtras();
        datosRuta = (DatosRuta) bundle.getSerializable(Constants.datosRutaServidor);

        setupPresenter();
        setupActionbar();

        setDesnivelPositivo();
        setDesnivelNegativo();
        setDesnivelAcumulado();
        setDifFisicia();
        setDifTecnica();
        setDistancia();
        setObservaciones();
        setTiempo();
        setTipoRuta();
        cargarMapa();
        new obtenerRutasCercanas().execute(0);
    }

    /*
     * Inflamos el menú en el actionbar
     */
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        //if(mostrarMenuFiltrar) {
        getMenuInflater().inflate(R.menu.menu_detalle_ruta_servidor, menu);
        //}
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()) {
            case R.id.menu_ruta_servidor_exportar:
                exportarRuta();
                return true;
            case android.R.id.home:
                finish();
                return true;

        }

        return super.onOptionsItemSelected(item);
    }

    /*
     * Seteamos el presentador
     */
    @Override
    public void setupPresenter() {
        presenter = new DetalleRutaServidorPresenterImplement(datosRuta);
    }

    /*
     * Seteamos la actionbar
     */
    @Override
    public void setupActionbar() {
        appbar.setTitle(getString(R.string.app_name));
        appbar.setSubtitle(presenter.getTituloRuta());
        setSupportActionBar(appbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
    }

    /*
     * Exprotamos la ruta en un archivo GPX
     */
    @Override
    public void exportarRuta() {
        new exportarArchivo().execute();
    }

    /*
     * Seteamos la distancia
     */
    @Override
    public void setDistancia() {
        textResultDistancia.setText(presenter.getDistancia() + " Km");
    }

    /*
     * Seteamos el tiempo
     */
    @Override
    public void setTiempo() {
        textResultTiempo.setText(presenter.getTiempo());
    }

    /*
     * Seteamos el desnivel positivo
     */
    @Override
    public void setDesnivelPositivo() {
        textResultDesnivel.setText(presenter.getDesnivelPositivo() + " m");
    }

    /*
     * Seteamos el desnivel negativo
     */
    @Override
    public void setDesnivelNegativo() {
        textResultDesnivelNegativo.setText(presenter.getDesnivelNegativo());
    }

    /*
     * Seteamos el desnivel acumulado
     */
    @Override
    public void setDesnivelAcumulado() {
        textResultadoDesnivelAcumulado.setText(presenter.getDesnivelAcumulado());
    }

    /*
     * Seteamos la dificultad física
     */
    @Override
    public void setDifFisicia() {
        textResultDifFisica.setText(presenter.getDifFisica());
    }

    /*
     * Seteamos la dificultad técnica
     */
    @Override
    public void setDifTecnica() {
        textResultDifTecnica.setText(presenter.getDifTecnica());
    }

    /*
     * Seteamos el tipo de ruta
     */
    @Override
    public void setTipoRuta() {
        textResultTipoRuta.setText(presenter.getTipoRuta());
    }

    /*
     * Seteamos las observaciones
     */
    @Override
    public void setObservaciones() {
        if (presenter.getObservaciones() != null && !presenter.getObservaciones().isEmpty()) {
            textResultObservaciones.setText(presenter.getObservaciones());
            textLblObservaciones.setVisibility(View.VISIBLE);
            textResultObservaciones.setVisibility(View.VISIBLE);
        } else {
            textLblObservaciones.setVisibility(View.GONE);
            textResultObservaciones.setVisibility(View.GONE);
        }
    }

    /*
     * Accedemos al mapa ampliado y mostramos el track de la ruta
     */
    @OnClick(R.id.mapView)
    @Override
    public void handleAmpliarMapa() {
        if(mapaCargado) {
            Intent intent = new Intent(DetalleRutaServidorActivity.this, MapaAmpliadoActivity.class);
            intent.putExtra(Constants.geoPointsCodificados, datosRuta.getGeoPointsCodificados());
            intent.putExtra(Constants.tituloRuta, datosRuta.getTituloRuta());
            startActivity(intent);
        } else{
            mostrarToast(getString(R.string.mapaAmplidado_error));
        }
    }

    /*
     * Llamamos a la API de mapquest para obtener el mapa estático y lo cargamos
     */
    @Override
    public void cargarMapa() {
        urlMapStatic = "https://www.mapquestapi.com/staticmap/v5/map?key=" + Constants.APIKeyMapQuest + "&shape=cmp|enc:" + presenter.getGeoPointsCodificados() + "&size=500,300";
        Picasso.with(getApplicationContext()).cancelRequest(mapView);
        Picasso.with(getApplicationContext())
                .load(urlMapStatic)
                .into(mapView, new Callback() {
                    @Override
                    public void onSuccess() {
                        if (progressBar2 != null && progressBar2.getVisibility() == View.VISIBLE) {
                            progressBar2.setVisibility(View.GONE);
                        }
                        mapaCargado = true;
                    }

                    @Override
                    public void onError() {
                        if (progressBar2 != null && progressBar2.getVisibility() == View.VISIBLE) {
                            progressBar2.setVisibility(View.GONE);
                        }
                        mapaCargado = false;
                    }
                });
    }

    /*
     * Mostramos o ocultamos el progressbar
     */
    @Override
    public void mostrarProgressbar(boolean mostrar) {
        if (mostrar) {
            progressbar.setVisibility(View.VISIBLE);
        } else {
            progressbar.setVisibility(View.GONE);
        }
    }

    /*
     * Mostramos o ocultamos el progressbar de la lista de rutas cercanas
     */
    @Override
    public void mostrarProgressbar2(boolean mostrar) {
        if (mostrar) {
            progressbar2.setVisibility(View.VISIBLE);
        } else {
            progressbar2.setVisibility(View.GONE);
        }
    }

    /*
     * Mostramos un toast con el mensaje recibido
     */
    @Override
    public void mostrarToast(String mensaje) {
        Toast.makeText(getApplicationContext(), mensaje, Toast.LENGTH_LONG).show();
    }

    /*
     * Seteamos el recyclerview donde se mostrarán las rutas cercanas
     */
    @Override
    public void setupRecyclerView() {
        setAdapter();
        listaRutasProximas.setLayoutManager(new LinearLayoutManager(this));
        listaRutasProximas.setAdapter(adapter);
    }

    /*
     * Seteamos el adapter del recycleview
     */
    @Override
    public void setAdapter() {
        adapter = new RutasServidorAdapter(new ArrayList<Ruta>(), this, this);
    }

    /*
     * Seteamos la lista de rutas cercanas obtenidas
     */
    @Override
    public void setRutas(List<Ruta> list) {
        adapter.setRutas(list);
    }

    /*
     * Al seleccionar una ruta, accedemos al detalla de la misma
     */
    @Override
    public void onItemClick(DatosRuta ruta) {
        Intent intent = new Intent(DetalleRutaServidorActivity.this, DetalleRutaServidorActivity.class);
        intent.putExtra(Constants.datosRutaServidor, ruta);
        startActivity(intent);
    }

    /*
     * Acción asincrona para obtener las rutas cercanas
     */
    protected class obtenerRutasCercanas extends AsyncTask<Integer, Void, List<Ruta>> {

        List<Ruta> list = new ArrayList<>();

        @Override
        protected void onPreExecute() {
            mostrarProgressbar2(true);
        }

        @Override
        protected List<Ruta> doInBackground(Integer... nextObjects) {

            //Inciamos el servicio de RutaApi
            if (servicio == null) {
                RutaApi.Builder builder = new RutaApi.Builder(AndroidHttp.newCompatibleTransport(), new AndroidJsonFactory(), null)
                        .setRootUrl(ConexionBackend.url);

                servicio = builder.build();
            }

            try {
                //Obtenemos las coordenadas iniciales
                GeoPoint geoPoint = presenter.getGeoPointInicial(presenter.getGeoPointsCodificados());

                if (geoPoint != null) {
                    //Buscamos las rutas próximas que encontramos en un radio de 5 km
                    list = servicio.getRutasByLocalizacionInicial(Constants.maxDistanciaPorRuta, geoPoint.getLatitude(), geoPoint.getLongitude(), nextObjects[0], false).execute().getItems();

                    if (list != null && list.size() > 0) {
                        for (Ruta r : list) {
                            if (r.getId().equals(datosRuta.getIdRuta())) {
                                list.remove(r);
                                break;
                            }
                        }
                    }
                }
            } catch (IOException e) {
                e.printStackTrace();
            }

            return list;
        }

        @Override
        protected void onPostExecute(List<Ruta> results) {

            if (progressbar2 != null && progressbar2.getVisibility() == View.VISIBLE) {
                mostrarProgressbar2(false);
            }

            if (results != null && results.size() > 0) {
                listaRutasProximas.setVisibility(View.VISIBLE);
                textSinResultados.setVisibility(View.GONE);
                setupRecyclerView();
                setRutas(results);

            } else {
                if (!refreshSwipe) {
                    listaRutasProximas.setVisibility(View.GONE);
                    textSinResultados.setVisibility(View.VISIBLE);
                }
            }
        }
    }

    /*
     * Clase para exportar una ruta a archivo GPX
     */
    private class exportarArchivo extends AsyncTask<Void, Void, Boolean> {

        boolean creado = false;

        @Override
        protected void onPreExecute() {
            mostrarProgressbar(true);
        }

        @Override
        protected Boolean doInBackground(Void... voids) {
            //Lista para guardar las localizaciones del track
            List<Location> locationList = new ArrayList<>();
            //Archivo GPX
            File file = new File(Environment.getExternalStorageDirectory(), Constants.carpetaArchivos + "/" + datosRuta.getTituloRuta() + ".gpx");

            if (!datosRuta.getGeoPointsCodificados().isEmpty()) {
                for (GeoPoint g : presenter.decodeGeopoints(datosRuta.getGeoPointsCodificados())) {
                    Location location = new Location("Location");
                    location.setLatitude(g.getLatitude());
                    location.setLongitude(g.getLongitude());
                    location.setLatitude(g.getLatitude());
                    locationList.add(location);
                }
            }

            //Creamos el archivo
            creado = ExportToGPXFile.crearGPXFile(file, datosRuta.getTituloRuta(), locationList, datosRuta.getIdRuta(), datosRuta.getIdUsuario());

            return creado;
        }

        @Override
        protected void onPostExecute(Boolean result) {
            mostrarProgressbar(false);
            if (result) {
                mostrarToast(getString(R.string.detalleRuta_usuario_exportarOK));
            } else {
                mostrarToast(getString(R.string.detalleRuta_usuario_exportarKO));
            }
        }
    }
}
