package com.uoc.christian.bttroute.DetalleRutaServidor;

import com.example.christian.myapplication.backend.dificultadFisicaApi.model.DificultadFisica;
import com.example.christian.myapplication.backend.dificultadTecnicaApi.model.DificultadTecnica;
import com.example.christian.myapplication.backend.tipoRutaApi.model.TipoRuta;
import com.google.android.gms.maps.model.LatLng;
import dataUtils.DatosFiltros;
import dataUtils.DatosRuta;
import dataUtils.PolyUtil;

import org.osmdroid.util.GeoPoint;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by christian on 1/11/17.
 */

public class DetalleRutaServidorPresenterImplement implements DetalleRutaServidorPresenter {

    private DatosRuta datosRuta;
    List<GeoPoint> lista = new ArrayList<>();

    public DetalleRutaServidorPresenterImplement(DatosRuta datosRuta){
        this.datosRuta = datosRuta;
        onCreate(datosRuta);
    }

    @Override
    public void onCreate(DatosRuta datosRuta) {
        this.datosRuta = datosRuta;
    }

    @Override
    public void onDestroy() {
        datosRuta = null;
    }

    /*
     * Devolvemos el título de la ruta
     */
    @Override
    public String getTituloRuta() {
        return datosRuta.getTituloRuta();
    }

    /*
     * Devolvemos el campo distancia
     */
    @Override
    public String getDistancia() {
        return String.valueOf(datosRuta.getDistancia());
    }

    /*
     * Devolvemos el campo tiempo
     */
    @Override
    public String getTiempo() {
        return datosRuta.getTiempo();
    }

    /*
     * Devolvemos el campo desnviel
     */
    @Override
    public String getDesnivelPositivo() {
        return String.valueOf(datosRuta.getDesnivelPositivo());
    }

    @Override
    public String getDesnivelNegativo() {
        return String.valueOf(datosRuta.getDesnivelNegativo());
    }

    @Override
    public String getDesnivelAcumulado() {
        return String.valueOf(datosRuta.getDesnivelAcumulado());
    }

    /*
     * Devolvemos el campo descripción dificultad física
     */
    @Override
    public String getDifFisica() {
        String descripcion="";
        for(DificultadFisica df : DatosFiltros.listaDificultadFisica){
            if(df.getId().toString().equals(datosRuta.getIdDificultadFisica().toString())){
                descripcion = df.getDescripcion();
            }
        }
        return descripcion;
    }

    /*
     * Devolvemos el campo descripción dificultad técnica
     */
    @Override
    public String getDifTecnica() {
        String descripcion="";
        for(DificultadTecnica dt : DatosFiltros.listaDificultadTecnica){
            if(dt.getId().toString().equals(datosRuta.getIdDificultadTecnica().toString())){
                descripcion = dt.getDescripcion();
            }
        }
        return descripcion;
    }

    /*
     * Devolvemos el campo descripción tipo ruta
     */
    @Override
    public String getTipoRuta() {
        String descripcion="";
        for(TipoRuta tr : DatosFiltros.listaTipoRuta){
            if(tr.getId().toString().equals(datosRuta.getIdTipoRuta().toString())){
                descripcion = tr.getDescripcion();
            }
        }
        return descripcion;
    }

    /*
     * Devolvemos el campo observaciones
     */
    @Override
    public String getObservaciones() {
        return datosRuta.getObservaciones()==null ? "" : datosRuta.getObservaciones();
    }

    @Override
    public String getGeoPointsCodificados() {
        return datosRuta.getGeoPointsCodificados();
    }

    @Override
    public List<GeoPoint> decodeGeopoints(String geoPointsCodificados) {
        if(!geoPointsCodificados.isEmpty()){
            List<LatLng> listaAux = PolyUtil.decode(geoPointsCodificados);

            for(int i=0;i<listaAux.size();i++){
                GeoPoint geoPoint = new GeoPoint(listaAux.get(i).latitude, listaAux.get(i).longitude);
                lista.add(geoPoint);
            }

        }
        return lista;
    }

    /*
     * Devolvemos las coordenadas del punto de inicio de la ruta
     */
    @Override
    public GeoPoint getGeoPointInicial(String geoPointsCodificados) {
        GeoPoint geoPoint = null;

        if(!geoPointsCodificados.isEmpty()){
            List<LatLng> listaAux = PolyUtil.decode(geoPointsCodificados);

            geoPoint = new GeoPoint(listaAux.get(0).latitude, listaAux.get(0).longitude);
        }
        return geoPoint;
    }
}
