package com.uoc.christian.bttroute.FiltrosBusqueda.Adapter;

import android.content.Context;
import android.support.annotation.IdRes;
import android.support.annotation.LayoutRes;
import android.support.annotation.NonNull;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.example.christian.myapplication.backend.dificultadFisicaApi.model.DificultadFisica;
import com.uoc.christian.bttroute.FiltrosBusqueda.FiltrosBusquedaActivity;
import com.uoc.christian.bttroute.R;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * Created by christian on 24/10/17.
 */

public class AdapterSpinnerDifFisica extends ArrayAdapter<DificultadFisica> {

    private Context context;
    private List<DificultadFisica> values;
    LayoutInflater inflater;

    public AdapterSpinnerDifFisica(Context context, int textViewResourceId, List<DificultadFisica> objects) {
        super(context, textViewResourceId, objects);
        this.context = context;
        this.values = objects;
        inflater = LayoutInflater.from(context);
    }

    @Override
    public int getCount(){
        return values.size();
    }

    @Override
    public DificultadFisica getItem(int position){
        return values.get(position);
    }

    @Override
    public long getItemId(int position){
        return position;
    }

    @Override
    public View getView(int position, View convertview, ViewGroup parent){
        convertview = inflater.inflate(R.layout.item_spinner,null);
        TextView label = (TextView)convertview.findViewById(R.id.textItemSpinner);
        label.setText(values.get(position).getDescripcion());

        return label;
    }

    @Override
    public View getDropDownView(int position, View convertView, ViewGroup parent){
        convertView = inflater.inflate(R.layout.item_spinner, null);

        if(position==0){
            TextView label = (TextView)convertView.findViewById(R.id.textItemSpinner);
            label.setText("");
        }else{
            TextView label = (TextView)convertView.findViewById(R.id.textItemSpinner);
            label.setText(values.get(position).getDescripcion());
        }

        return convertView;
    }
}
