package com.uoc.christian.bttroute.FiltrosBusqueda.Adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.example.christian.myapplication.backend.tipoRutaApi.model.TipoRuta;
import com.uoc.christian.bttroute.R;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;

/**
 * Created by christian on 25/10/17.
 */

public class AdapterSpinnerTipoRuta extends ArrayAdapter<TipoRuta> {

    @BindView(R.id.textItemSpinner)
    TextView textItemSpinner;

    private Context context;
    private List<TipoRuta> values = new ArrayList<>();
    LayoutInflater inflater;


    public AdapterSpinnerTipoRuta(Context context, int textViewResourceId, List<TipoRuta> objects) {
        super(context, textViewResourceId, objects);
        this.context = context;
        this.values = objects;
        inflater = (LayoutInflater.from(context));
    }

    @Override
    public int getCount(){
        return values.size();
    }

    @Override
    public TipoRuta getItem(int position){
        return values.get(position);
    }

    @Override
    public long getItemId(int position){
        return position;
    }

    @Override
    public View getView(int position, View convertview, ViewGroup parent){
        convertview = inflater.inflate(R.layout.item_spinner, null);
        TextView label = (TextView)convertview.findViewById(R.id.textItemSpinner);
        label.setText(values.get(position).getDescripcion());

        return label;
    }

    @Override
    public View getDropDownView(int position, View convertView, ViewGroup parent){
        convertView = inflater.inflate(R.layout.item_spinner, null);

        if(position==0){
            TextView label = (TextView)convertView.findViewById(R.id.textItemSpinner);
            label.setText("");
        }else{
            TextView label = (TextView)convertView.findViewById(R.id.textItemSpinner);
            label.setText(values.get(position).getDescripcion());
        }


        return convertView;
    }
}
