package com.uoc.christian.bttroute.FiltrosBusqueda;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.MenuItem;
import android.widget.Button;
import android.widget.EditText;
import android.widget.SeekBar;
import android.widget.Spinner;
import android.widget.TextView;

import com.example.christian.myapplication.backend.dificultadFisicaApi.model.DificultadFisica;
import com.example.christian.myapplication.backend.dificultadTecnicaApi.model.DificultadTecnica;
import com.example.christian.myapplication.backend.tipoRutaApi.model.TipoRuta;
import dataUtils.Constants;
import dataUtils.DatosFiltros;
import com.uoc.christian.bttroute.FiltrosBusqueda.Adapter.AdapterSpinnerDifFisica;
import com.uoc.christian.bttroute.FiltrosBusqueda.Adapter.AdapterSpinnerDifTecnica;
import com.uoc.christian.bttroute.FiltrosBusqueda.Adapter.AdapterSpinnerTipoRuta;
import com.uoc.christian.bttroute.PantallaInicial.PantallaInicialActivity;
import com.uoc.christian.bttroute.R;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class FiltrosBusquedaActivity extends AppCompatActivity implements FiltrosBusquedaView {

    @BindView(R.id.appbar)
    Toolbar appbar;
    @BindView(R.id.editEntradaLugar)
    EditText editEntradaLugar;
    @BindView(R.id.seekDistancia)
    SeekBar seekDistancia;
    @BindView(R.id.spinnerDifFisica)
    Spinner spinnerDifFisica;
    @BindView(R.id.spinnerDifTecnica)
    Spinner spinnerDifTecnica;
    @BindView(R.id.spinnerTipoRuta)
    Spinner spinnerTipoRuta;
    @BindView(R.id.btnFiltrar)
    Button btnFiltrar;
    @BindView(R.id.textKm)
    TextView textKm;
    @BindView(R.id.btnLimpiarFiltros)
    Button btnLimpiarFiltros;

    private FiltrosBusquedaPresenterImplementer presenter;
    private AdapterSpinnerDifFisica adapaterSpinnerDifFisica;
    private AdapterSpinnerDifTecnica adapterSpinnerDifTecnica;
    private AdapterSpinnerTipoRuta adapterSpinnerTipoRuta;
    private int stepSize = 5;
    private int progres = 10;
    private List<DificultadFisica> listDifFisca = new ArrayList<>();
    private List<DificultadTecnica> listDifTecnica = new ArrayList<>();
    private List<TipoRuta> listTipoRuta = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_filtros_busqueda);
        ButterKnife.bind(this);
        setupActionBar();
        setupPresneter();
        inflateSpinnerDifFisica();
        inflateSpinnerDifTecnica();
        inflateSpinnerTipoRuta();
        setLugar();
        setDifFisica();
        setDifTecnica();
        setTipoRuta();
        setDistancia();

        //Listener del seekbar
        seekDistancia.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {

            @Override
            public void onProgressChanged(SeekBar seekBar, int i, boolean b) {
                progres = (i / stepSize) * stepSize;
                textKm.setText(progres + " Km");
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });

    }

    /*
     * Seteamos el presentador
     */
    @Override
    public void setupPresneter() {
        presenter = new FiltrosBusquedaPresenterImplementer(this, getApplicationContext());
    }

    /*
     * Seteamos la actionbar
     */
    @Override
    public void setupActionBar() {
        appbar.setTitle(getString(R.string.app_name));
        appbar.setSubtitle(getString(R.string.filtros_titulo));
        setSupportActionBar(appbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                return true;
        }
        return super.onOptionsItemSelected(item);
    }

    /*
     * Si el usuario aplica algún tipo de filtro, volvemos a la pantalla inicial y esta llamará
     * al método del fragment asociado y se mostrará la lista de rutas que cumpla con los
     * criterios seleccionados.
     */
    @OnClick(R.id.btnFiltrar)
    @Override
    public void handleBuscar() {
        DatosFiltros.lugar = editEntradaLugar.getText().toString();
        DatosFiltros.distancia = progres;
        DificultadFisica dificultadFisica = (DificultadFisica) spinnerDifFisica.getSelectedItem();
        DatosFiltros.idDifFisica = dificultadFisica.getId();
        DificultadTecnica dificultadTecnica = (DificultadTecnica) spinnerDifTecnica.getSelectedItem();
        DatosFiltros.idDifTecnica = dificultadTecnica.getId();
        TipoRuta tipoRuta = (TipoRuta) spinnerTipoRuta.getSelectedItem();
        DatosFiltros.idTipoRuta = tipoRuta.getId();
        DatosFiltros.filtrosAplicados = true;

        Intent intent = new Intent(FiltrosBusquedaActivity.this, PantallaInicialActivity.class);
        setResult(Activity.RESULT_OK, intent);
        finish();
    }

    /*
     * Si el usuario limpia los filtros, volvemos a la pantalla inicial y esta llamará al método
     * del fragment asociado y se mostrará la lista de rutas cercanas a su posición
     */
    @OnClick(R.id.btnLimpiarFiltros)
    @Override
    public void handleLimpiarFiltros() {
        DatosFiltros.lugar = "";
        DatosFiltros.distancia = Constants.minDistanciaSeekbar;
        DatosFiltros.idDifFisica = 0;
        DatosFiltros.idDifTecnica = 0;
        DatosFiltros.idTipoRuta = 0;
        DatosFiltros.filtrosAplicados = false;

        Intent intent = new Intent(FiltrosBusquedaActivity.this, PantallaInicialActivity.class);
        setResult(RESULT_OK, intent);
        finish();
    }

    /*
     * Cargamos los datos en el spinner de dificultad física
     */
    @Override
    public void inflateSpinnerDifFisica() {

        listDifFisca = presenter.getListaDifFisica();

        DificultadFisica dificultadFisica = new DificultadFisica();
        dificultadFisica.setId((long) 0);
        dificultadFisica.setDescripcion("Selecciona...");

        if (!listDifFisca.contains(dificultadFisica))
            listDifFisca.add(0, dificultadFisica);

        adapaterSpinnerDifFisica = new AdapterSpinnerDifFisica(this, android.R.layout.simple_spinner_item, listDifFisca);
        adapaterSpinnerDifFisica.setDropDownViewResource(R.layout.item_spinner);
        spinnerDifFisica.setAdapter(adapaterSpinnerDifFisica);
    }

    /*
     * Cargamos los datos en el spinner de dificultad técnica
     */
    @Override
    public void inflateSpinnerDifTecnica() {

        listDifTecnica = presenter.getListaDifTecnica();

        DificultadTecnica dificultadTecnica = new DificultadTecnica();
        dificultadTecnica.setId((long) 0);
        dificultadTecnica.setDescripcion("Selecciona...");

        if (!listDifTecnica.contains(dificultadTecnica))
            listDifTecnica.add(0, dificultadTecnica);

        adapterSpinnerDifTecnica = new AdapterSpinnerDifTecnica(this, android.R.layout.simple_spinner_item, listDifTecnica);
        adapterSpinnerDifTecnica.setDropDownViewResource(R.layout.item_spinner);
        spinnerDifTecnica.setAdapter(adapterSpinnerDifTecnica);
    }

    /*
     * Cargamos los datos en el spinner de tipo de rutas
     */
    @Override
    public void inflateSpinnerTipoRuta() {

        listTipoRuta = presenter.getListaTipoRuta();

        TipoRuta tipoRuta = new TipoRuta();
        tipoRuta.setId((long) 0);
        tipoRuta.setDescripcion("Selecciona...");

        if (!listTipoRuta.contains(tipoRuta))
            listTipoRuta.add(0, tipoRuta);

        adapterSpinnerTipoRuta = new AdapterSpinnerTipoRuta(this, android.R.layout.simple_spinner_item, listTipoRuta);
        adapterSpinnerTipoRuta.setDropDownViewResource(R.layout.item_spinner);
        spinnerTipoRuta.setAdapter(adapterSpinnerTipoRuta);

    }

    /*
     * Seteamos la distancia
     */
    @Override
    public void setDistancia() {
        textKm.setText(presenter.getDistancia() + " Km");
        seekDistancia.setProgress(Integer.parseInt(presenter.getDistancia()));
        progres = Integer.parseInt(presenter.getDistancia());
    }

    /*
     * Seteamos el campo lugar
     */
    @Override
    public void setLugar() {
        editEntradaLugar.setText(presenter.getLugar());
    }

    /*
     * Seteamos el spinner dificultad física
     */
    @Override
    public void setDifFisica() {
        spinnerDifFisica.setSelection(presenter.getDifFisica());
    }

    /*
     * Seteamos el spinner dificultad técnica
     */
    @Override
    public void setDifTecnica() {
        spinnerDifTecnica.setSelection(presenter.getDifTecnica());
    }

    /*
     * Seteamos el spinner tipo de ruta
     */
    @Override
    public void setTipoRuta() {
        spinnerTipoRuta.setSelection(presenter.getTipoRuta());
    }
}
