package com.uoc.christian.bttroute.FiltrosBusqueda;

import android.content.Context;

import com.example.christian.myapplication.backend.dificultadFisicaApi.model.DificultadFisica;
import com.example.christian.myapplication.backend.dificultadTecnicaApi.model.DificultadTecnica;
import com.example.christian.myapplication.backend.tipoRutaApi.model.TipoRuta;
import dataUtils.Constants;
import dataUtils.DatosFiltros;

import java.util.List;

/**
 * Created by Christian on 18/10/2017.
 */

public class FiltrosBusquedaPresenterImplementer implements FiltrosBusquedaPresenter {

    FiltrosBusquedaView filtrosBusquedaView;
    Context context;

    public FiltrosBusquedaPresenterImplementer(FiltrosBusquedaView filtrosBusquedaView, Context context){
        this.filtrosBusquedaView = filtrosBusquedaView;
        this.context = context;

        onCreate(this.filtrosBusquedaView, this.context);
    }

    @Override
    public void onCreate(FiltrosBusquedaView filtrosBusquedaView, Context context) {
        this.filtrosBusquedaView = filtrosBusquedaView;
        this.context = context;
    }

    @Override
    public void onDestroy() {
        filtrosBusquedaView = null;
        context = null;
    }

    @Override
    public List<DificultadFisica> getListaDifFisica() {
        //DificultadFisica[] values = new DificultadFisica[DatosFiltros.listaDificultadFisica.size()];
        //values = DatosFiltros.listaDificultadFisica.toArray(values);
        return DatosFiltros.listaDificultadFisica;
    }

    @Override
    public List<DificultadTecnica> getListaDifTecnica() {
        return DatosFiltros.listaDificultadTecnica;
    }

    @Override
    public List<TipoRuta> getListaTipoRuta() {
        return DatosFiltros.listaTipoRuta;
    }

    @Override
    public String getDistancia() {
        String distancia = "";
        if(DatosFiltros.filtrosAplicados){
            distancia = String.valueOf(DatosFiltros.distancia);
        }else {
            distancia = String.valueOf(Constants.minDistanciaSeekbar);
        }
        return distancia;
    }

    @Override
    public String getLugar() {
        String lugar = "";
        if(DatosFiltros.filtrosAplicados){
            lugar = DatosFiltros.lugar;
        }
        return lugar;
    }

    @Override
    public Integer getDifFisica() {
        int dif = 0;
        if(DatosFiltros.filtrosAplicados){
            dif = (int) DatosFiltros.idDifFisica;
        }
        return dif;
    }

    @Override
    public Integer getDifTecnica() {
        int dif = 0;
        if(DatosFiltros.filtrosAplicados){
            dif = (int) DatosFiltros.idDifTecnica;
        }
        return dif;
    }

    @Override
    public Integer getTipoRuta() {
        int tipo = 0;
        if(DatosFiltros.filtrosAplicados){
            tipo = (int) DatosFiltros.idTipoRuta;
        }
        return tipo;
    }
}
