package com.uoc.christian.bttroute.GuardarRuta;

import android.content.Context;

import com.example.christian.myapplication.backend.dificultadFisicaApi.model.DificultadFisica;
import com.example.christian.myapplication.backend.dificultadTecnicaApi.model.DificultadTecnica;
import com.example.christian.myapplication.backend.tipoRutaApi.model.TipoRuta;
import dataUtils.CrearUUID;
import dataUtils.DatosFiltros;
import com.uoc.christian.bttroute.R;

import java.net.MalformedURLException;
import java.util.List;

import dataUtils.CheckConexionInternet;

/**
 * Created by christian on 23/10/17.
 */

public class GuardarRutaPresenterImplement implements GuardarRutaPresenter {

    private Context context;
    private GuardarRutaView guardarRutaView;
    private boolean tenemosConexion = true;

    public GuardarRutaPresenterImplement(GuardarRutaView guardarRutaView, Context context){
        this.context = context;
        this.guardarRutaView = guardarRutaView;
        onCreate(this.guardarRutaView,this.context);
    }

    @Override
    public void onCreate(GuardarRutaView guardarRutaView, Context context) {
        this.context = context;
        this.guardarRutaView = guardarRutaView;
    }

    @Override
    public void onDestroy() {
        context = null;
        guardarRutaView = null;
    }

    @Override
    public String obtenerUUID() {
        CrearUUID crearUUID = new CrearUUID();
        return crearUUID.crearUUID();
    }

    @Override
    public boolean comprobarCampos(String titulo) {
        if(titulo.isEmpty()){
            guardarRutaView.mostrarToast(context.getString(R.string.guardarRuta_mensaje_faltanDatos));
            return false;
        }else{
            return true;
        }
    }

    @Override
    public List<DificultadFisica> getListaDifFisica() {
        return DatosFiltros.listaDificultadFisica;
    }

    @Override
    public List<DificultadTecnica> getListaDifTecnica() {
        return DatosFiltros.listaDificultadTecnica;
    }

    @Override
    public List<TipoRuta> getListaTipoRuta() {
        return DatosFiltros.listaTipoRuta;
    }

    @Override
    public boolean comprobarConexion() {
        try {
            tenemosConexion = CheckConexionInternet.tenemosConexion(context);
        } catch (MalformedURLException e) {
            e.printStackTrace();
        }

        return tenemosConexion;
    }

}
