package com.uoc.christian.bttroute.PantallaInicial;

import android.Manifest;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.os.Environment;
import android.support.design.widget.NavigationView;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.Fragment;
import android.support.v4.view.GravityCompat;
import android.support.v4.widget.DrawerLayout;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import com.crashlytics.android.Crashlytics;
import com.facebook.login.LoginManager;
import com.facebook.login.widget.ProfilePictureView;
import com.uoc.christian.bttroute.CambioContrasena.CambioContrasenaFragment;
import dataUtils.Constants;
import dataUtils.DatosFiltros;
import dataUtils.DatosRuta;
import dataUtils.ListasRutas;
import dataUtils.SharedPrefsUtils;
import com.uoc.christian.bttroute.DetalleRutaGrabada.DetallaRutaGrabadaActivity;
import com.uoc.christian.bttroute.DetalleRutaServidor.DetalleRutaServidorActivity;
import com.uoc.christian.bttroute.ExploradorArchivos.ExploradorArchivosFragment;
import com.uoc.christian.bttroute.FiltrosBusqueda.FiltrosBusquedaActivity;
import com.uoc.christian.bttroute.Login.LoginActivity;
import com.uoc.christian.bttroute.MisRutas.MisRutasFragment;
import com.uoc.christian.bttroute.R;
import com.uoc.christian.bttroute.RegistroActividad.RegistroActividadActivity;
import com.uoc.christian.bttroute.RutasServidorBusqueda.RutasServidorFragment;

import org.osmdroid.util.GeoPoint;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import io.fabric.sdk.android.Fabric;

import static android.content.Intent.FLAG_ACTIVITY_CLEAR_TASK;
import static android.content.Intent.FLAG_ACTIVITY_CLEAR_TOP;
import static android.content.Intent.FLAG_ACTIVITY_NEW_TASK;

public class PantallaInicialActivity extends AppCompatActivity implements PantallaInicialView {

    @BindView(R.id.appbar)
    Toolbar appbar;
    @BindView(R.id.navview)
    NavigationView navview;
    @BindView(R.id.drawer_layout)
    DrawerLayout drawerLayout;

    MenuItem menuItem;
    boolean mostrarMenuFiltrar = false;
    public static final int PANTALLA_FILTROS = 200;
    public static final int PANTALLA_MIS_RUTAS = 300;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pantalla_inicial);
        ButterKnife.bind(this);
        Fabric.with(this, new Crashlytics());
        setupAcitionbar();
        setNavigationApp();
        crearCarpeta();
        ActivityCompat.requestPermissions(this,new String[]{Manifest.permission.ACCESS_FINE_LOCATION}, 1);
        setNombreUsuario();
        setImagenUsuario();

        //Si hemos realizado el login con una cuenta de facebook, desactivamos la opción de "cambiar contraseña" del menú lateral.
        if (SharedPrefsUtils.getBooleanPreference(getApplicationContext(), getString(R.string.key_isLoginFacebook),false)) {
            navview.getMenu().getItem(4).setVisible(false);
        }

        DatosFiltros.filtrosAplicados=false;
    }

    private void setNavigationApp(){

        navview.setNavigationItemSelectedListener(new NavigationView.OnNavigationItemSelectedListener() {

            MenuItem prevMenuItem = null;

            @Override
            public boolean onNavigationItemSelected(MenuItem menuItem) {

                boolean fragmentTransaction = false;
                Fragment fragment = null;

                switch (menuItem.getItemId()){
                    case R.id.menu_registrar_ruta:
                        mostrarMenuFiltrar = false;
                        invalidateOptionsMenu();
                        Intent intent = new Intent(PantallaInicialActivity.this, RegistroActividadActivity.class);
                        intent.putExtra(Constants.rutaNueva, true);
                        startActivity(intent);
                        break;
                    case R.id.menu_mis_rutas:
                        fragment = new MisRutasFragment();
                        fragmentTransaction = true;
                        mostrarMenuFiltrar = false;
                        invalidateOptionsMenu();
                        break;
                    case R.id.menu_buscar:
                        fragment = new RutasServidorFragment();
                        fragmentTransaction = true;
                        mostrarMenuFiltrar = true;
                        invalidateOptionsMenu();
                        break;
                    case R.id.menu_cargar:
                        mostrarMenuFiltrar = false;
                        invalidateOptionsMenu();
                        fragment = new ExploradorArchivosFragment();
                        fragmentTransaction = true;
                        mostrarMenuFiltrar = false;
                        invalidateOptionsMenu();
                        break;
                    case R.id.menu_cambio_contrasena:
                        fragment = new CambioContrasenaFragment();
                        fragmentTransaction = true;
                        mostrarMenuFiltrar = false;
                        invalidateOptionsMenu();
                        break;
                    case R.id.menu_cerrar_sesion:
                        showExitAppDialog();
                        break;
                }



                if(fragmentTransaction) {
                    getSupportFragmentManager().beginTransaction()
                            .replace(R.id.frameContenido, fragment)
                            .addToBackStack(null)
                            .commit();

                    getSupportActionBar().setSubtitle(menuItem.getTitle());
                }

                /**/

                //Checkeamos el elemento y cambiamos el titulo
                menuItem.setChecked(true);

                prevMenuItem = menuItem;
                drawerLayout.closeDrawers();

                return false;
            }
        });

        getSupportFragmentManager().beginTransaction()
                .replace(R.id.frameContenido, new MisRutasFragment())
                .commit();

        getSupportActionBar().setSubtitle(getString(R.string.misRutas_titulo));
    }

    @Override
    public void onBackPressed(){
        showExitAppDialog();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data){
        if(requestCode == PANTALLA_FILTROS){
            if(resultCode == RESULT_OK){
                Fragment fragment = getSupportFragmentManager().findFragmentById(R.id.frameContenido);
                RutasServidorFragment rutasServidorFragment = (RutasServidorFragment)fragment;
                rutasServidorFragment.actualizarLista();
            }
        } else if (requestCode == PANTALLA_MIS_RUTAS){
            if(resultCode == RESULT_OK) {
                Fragment fragment = getSupportFragmentManager().findFragmentById(R.id.frameContenido);
                MisRutasFragment misRutasFragment = (MisRutasFragment)fragment;
                misRutasFragment.obtenerRutasUsuario();
            }
        }
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        int id = item.getItemId();

        if(id==R.id.menu_filtrar){
            Intent intent = new Intent(PantallaInicialActivity.this, FiltrosBusquedaActivity.class);
            startActivityForResult(intent,PANTALLA_FILTROS);
        }else if(id == android.R.id.home){
            drawerLayout.openDrawer(GravityCompat.START);
        }

        return super.onOptionsItemSelected(item);
    }

    private void setupAcitionbar(){
        appbar.setTitle(getString(R.string.app_name));
        setSupportActionBar(appbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
    }

    @Override
    public void showExitAppDialog() {
        AlertDialog.Builder builder;
        builder = new AlertDialog.Builder(this, R.style.AlertDialogCustom);
        builder.setTitle(getString(R.string.pantallaInicial_titulo_mensaje_salir))
                .setMessage(R.string.pantallaInicial_mensaje_salir)
                .setPositiveButton(R.string.buttons_alert_aceptar, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {

                        ListasRutas.listaMisRutas = null;
                        ListasRutas.listaRutasServ = null;
                        //Limpiamos datos de la sesión
                        SharedPrefsUtils.clearSharedPreferences(getApplicationContext());

                        LoginManager.getInstance().logOut();
                        Intent i = new Intent(PantallaInicialActivity.this, LoginActivity.class);
                        i.setFlags(FLAG_ACTIVITY_NEW_TASK | FLAG_ACTIVITY_CLEAR_TASK | FLAG_ACTIVITY_CLEAR_TOP);
                        startActivity(i);
                        finish();

                    }
                })
                .setNegativeButton(R.string.buttons_alert_cancelar, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {
                        // do nothing
                    }
                })
                .create()
                .show();
    }

    @Override
    public void setNombreUsuario() {
        View header = navview.getHeaderView(0);
        TextView textView = (TextView)header.findViewById(R.id.textUsuario);
        textView.setText(SharedPrefsUtils.getStringPreference(getApplicationContext(), getString(R.string.key_usuario)));
    }

    @Override
    public void setImagenUsuario() {

        View header = navview.getHeaderView(0);
        ImageView imgFondo = (ImageView)header.findViewById(R.id.imgFondo);

        View header2 = navview.getHeaderView(0);
        ProfilePictureView imageFacebook = (ProfilePictureView) header2.findViewById(R.id.imgUsuarioFacebook);

        View header3 = navview.getHeaderView(0);
        ImageView imgUser = (ImageView)header3.findViewById(R.id.imgUser);


        if(SharedPrefsUtils.getBooleanPreference(getApplicationContext(), getString(R.string.key_isLoginFacebook),false)){
            imgUser.setVisibility(View.GONE);
            imgFondo.setVisibility(View.VISIBLE);
            imageFacebook.setVisibility(View.VISIBLE);
            imageFacebook.setProfileId(SharedPrefsUtils.getStringPreference(getApplicationContext(),getString(R.string.key_idUsuarioFacebook)));
        }else{
            imgUser.setVisibility(View.VISIBLE);
            imgFondo.setVisibility(View.GONE);
            imageFacebook.setVisibility(View.GONE);
        }

    }

    @Override
    public void irARegistroActividad() {
        Intent intent = new Intent(PantallaInicialActivity.this, RegistroActividadActivity.class);
        intent.putExtra(Constants.rutaNueva, true);
        startActivity(intent);
    }

    /*
    * Cargamos el menú
    */
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        if(mostrarMenuFiltrar) {
            getMenuInflater().inflate(R.menu.menu_filtrar_ruta, menu);
        }
        return true;
    }

    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        switch (requestCode) {
            case 1: {
                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {

                } else {
                    // permission denied, boo! Disable the
                    // functionality that depends on this permission.
                }
                return;
            }
            // other 'case' lines to check for other
            // permissions this app might request
        }
    }

    /***********************
     * Crear carpeta
     */
    private void crearCarpeta(){
        String folder = "BttRouteMaps";

        File f = new File(Environment.getExternalStorageDirectory(), folder);
        if (!f.exists()) {
            f.mkdirs();
        }
    }

    /*
     * Método que accede al detalle de la ruta del usuario
     */
    public void mostrarDetalleRuta(DatosRuta datosRuta){
        Intent intent = new Intent(PantallaInicialActivity.this, DetallaRutaGrabadaActivity.class);
        intent.putExtra(Constants.datosRutaUsuario, datosRuta);
        startActivityForResult(intent, PANTALLA_MIS_RUTAS);
    }

    /*
     * Método que accede al detalle de la ruta del servidor
     */
    public void mostrarDetalleRutaServidor(DatosRuta ruta){
        Intent intent = new Intent(PantallaInicialActivity.this, DetalleRutaServidorActivity.class);
        intent.putExtra(Constants.datosRutaServidor,ruta);
        startActivity(intent);
    }

    /*
     * Método que accede a la pantalla de crear ruta con una ruta cargada desde el explorador
     */
    public void cargarRuta(boolean nuevaRuta, String idGPXFile, List<GeoPoint> lista){
        Intent intent = new Intent(PantallaInicialActivity.this, RegistroActividadActivity.class);
        intent.putExtra(Constants.rutaNueva, nuevaRuta);
        intent.putExtra(Constants.idRutaOrigen, idGPXFile);
        intent.putParcelableArrayListExtra(Constants.listaPoints, (ArrayList<GeoPoint>) lista);
        startActivity(intent);
    }
}
