package com.uoc.christian.bttroute.RegistroActividad;

import android.location.Criteria;
import android.location.Location;

import com.google.android.gms.maps.model.LatLng;
import dataUtils.PolyUtil;

import org.osmdroid.util.GeoPoint;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by Christian on 14/10/2017.
 */

public class RegistroActividadPresenterImplement implements RegistroActividadPresenter {


    RegistroActividadView registroActividadView;
    private ArrayList<GeoPoint> geoPoints = new ArrayList<>();
    private ArrayList<GeoPoint> finalGeoPoints = new ArrayList<>();
    private ArrayList<Integer> listAltitud = new ArrayList<>();
    private List<Integer> desnivelesPositivos = new ArrayList<>();
    private List<Integer> desnivelesNegativos = new ArrayList<>();

    private float distancia=0;
    private float distanciaTotal=0;
    private double velocidadMaxima=0;
    private double velocidadMedia=0;
    private int desnivelTotalNegativo=0;
    private int desnivelTotalPositivo=0;
    private int desnivelAcumulado=0;
    private GeoPoint geopoint;

    public RegistroActividadPresenterImplement(RegistroActividadView registroActividadView, ArrayList<GeoPoint> listaNueva){
        this.registroActividadView = registroActividadView;
        this.geoPoints = listaNueva;
        onCreate(this.registroActividadView, this.geoPoints);
    }

    @Override
    public void onCreate(RegistroActividadView registroActividadView, ArrayList<GeoPoint> list) {
        this.registroActividadView = registroActividadView;
        this.geoPoints = list;
    }

    @Override
    public void onDestroy() {
        registroActividadView = null;
        geoPoints = null;
    }

    @Override
    public void guardarCoordenadasTemp(GeoPoint point) {
        geoPoints.add(point);
    }

    @Override
    public void guardarAltitud(Integer altitud) {
        listAltitud.add(altitud);
    }

    @Override
    public ArrayList<GeoPoint> getCoordenadas() {
        return finalGeoPoints;
    }

    @Override
    public void setDistancia(float dist) {
        String distancia="0";

        if(dist != 0.0){
            distancia = String.valueOf(dist);
        }
        registroActividadView.setearDistancia(distancia);
    }

    @Override
    public void calcularDistancia(Location location) {
        GeoPoint pointInicial;

        if(geoPoints!=null && geoPoints.size()>0) {
            if(geoPoints.size()==1){
                pointInicial = geoPoints.get(0);
            }else {
                pointInicial = geoPoints.get(geoPoints.size() - 1);
            }

            double startLatitude = pointInicial.getLatitude();
            double startLongitude = pointInicial.getLongitude();

            double endLatitude = location.getLatitude();
            double endLongitude = location.getLongitude();

            Location locationA = new Location("A");
            locationA.setLatitude(startLatitude);
            locationA.setLongitude(startLongitude);

            Location locationB = new Location("B");
            locationB.setLatitude(endLatitude);
            locationB.setLongitude(endLongitude);



            //Obtenemos la distancia en Km.
            distancia = locationA.distanceTo(locationB)/1000;

            distanciaTotal += distancia;

            float valor = BigDecimal.valueOf(distanciaTotal).setScale(2, BigDecimal.ROUND_HALF_UP).floatValue();

            setDistancia(valor);
        }
    }

    /*
     * Codificamos los geopoints creados en la ruta
     */
    @Override
    public String codificarGeopoints(List<GeoPoint> list) {
        List<LatLng> gpCodificados = new ArrayList<>();

        if(list!=null && list.size()>0) {
            for (GeoPoint g : list) {
                LatLng latLng = new LatLng(g.getLatitude(), g.getLongitude());
                gpCodificados.add(latLng);
            }
        }

        return PolyUtil.encode(gpCodificados);
    }

    @Override
    public void guardarVelocidadMaxima(double velocidad) {
        if(velocidad>velocidadMaxima){
            velocidadMaxima = velocidad;
        }
    }

    @Override
    public float getVelocidadMaxima() {
        float valor = BigDecimal.valueOf(velocidadMaxima).setScale(1, BigDecimal.ROUND_HALF_UP).floatValue();
        return valor;
    }

    @Override
    public Integer getDesnivelPositivo() {

        //Calculamos el desnivel positivo
        for(Integer i: desnivelesPositivos){
            desnivelTotalPositivo += i;
        }

        return desnivelTotalPositivo;
    }

    @Override
    public Integer getDesnivelNegativo() {

        //Calculamos el desnivel negativo
        for(Integer i: desnivelesNegativos){
            desnivelTotalNegativo += i;
        }

        return desnivelTotalNegativo;
    }

    @Override
    public Integer getDesnivelAcumulado() {
        desnivelAcumulado = desnivelTotalNegativo + desnivelTotalPositivo;
        return desnivelAcumulado;
    }

    @Override
    public void separarDesniveles(){
        for(int i=0; i<listAltitud.size();i++){
            if(i!=0){
                if(listAltitud.get(i)>listAltitud.get(i-1)){
                    desnivelesPositivos.add(listAltitud.get(i)-listAltitud.get(i-1));
                }else{
                    desnivelesNegativos.add(listAltitud.get(i-1)-listAltitud.get(i));
                }
            }
        }
    }

    @Override
    public void calcularVelocidadMedia(Location location, int tiempo) {

        if(geoPoints.size()>1){
            if(geoPoints.size()==2) {
                geopoint = geoPoints.get(0);
                finalGeoPoints.add(geopoint);
            }

            double lat1 = geopoint.getLatitude();
            double lon1 = geopoint.getLongitude();

            double latNueva = location.getLatitude();
            double lonNueva = location.getLongitude();

            Location location1 = new Location("inicio");
            location1.setLatitude(lat1);
            location1.setLongitude(lon1);

            Location location2 = new Location("fin");
            location2.setLatitude(latNueva);
            location2.setLongitude(lonNueva);

            float distance = location1.distanceTo(location2);

            if(distance>=10){
                double v = (distanciaTotal*1000)/tiempo; //velocidad media m/s
                velocidadMedia = (v*18)/5;//convertimos a km/h

                float valorVelMedia = BigDecimal.valueOf(velocidadMedia).setScale(1, BigDecimal.ROUND_HALF_UP).floatValue();
                registroActividadView.setearVelocidadMedia(String.valueOf(valorVelMedia));

                GeoPoint g = new GeoPoint(latNueva,lonNueva);
                geopoint = g;

                /* Guardamos la coordenada en la array definitiva de la ruta.
                 * El motivo de realizar este paso aquí, es que queremos guardar una nueva posición a partir de los 10 metros
                 * de distancia entre dos puntos. El problema de guardar todos los geopoints captados por el GPS, es que para
                 * una ruta podemos tener 5000, 4000...geopoints. Esto hace que a la hora de codificar los geopoints para obtener
                 * el mapa estático con la ruta, no lo obtengamos debido a que tenemos una URL que sobrepasa el máximo de longitud.
                 */
                finalGeoPoints.add(g);
            }
        }
    }

    @Override
    public float calcularGrados(Location location) {

        float t = (360 - location.getBearing());
        if (t < 0) {
            t += 360;
        }
        if (t > 360) {
            t -= 360;
        }

        t = (int) t;
        t = t / 5;
        t = (int) t;
        t = t * 5;

        return t;
    }

    /*
     * Establecemos los parámetros para el GPS
     */
    @Override
    public Criteria getCriteria() {
        Criteria criteria = new Criteria();
        criteria.setPowerRequirement(Criteria.POWER_HIGH);
        criteria.setAccuracy(Criteria.ACCURACY_FINE);
        criteria.setSpeedRequired(true);
        criteria.setVerticalAccuracy(Criteria.ACCURACY_HIGH);
        criteria.setHorizontalAccuracy(Criteria.ACCURACY_HIGH);
        criteria.setAltitudeRequired(true);
        criteria.setSpeedAccuracy(Criteria.POWER_HIGH);
        return criteria;
    }

    /*
     * Devolvemos en segundos el total de tiempo en marcha
     */
    @Override
    public int getTiempoEnSegundos(String tiempo) {
        String[] values = tiempo.split("\\:");
        int segundos;
        int h = Integer.parseInt(values[0]) * 3600;
        int m = Integer.parseInt(values[1]) * 60;
        int s = Integer.parseInt(values[2]);

        segundos = h + m + s;

        return segundos;
    }
}
