package com.uoc.christian.bttroute.RegistroUsuario;

import android.content.Context;

import java.net.MalformedURLException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dataUtils.CheckConexionInternet;

/**
 * Created by christian on 6/10/17.
 */

public class RegistroPresenterImplement implements RegistroPresenter {

    RegistroView registroView;
    Context context;
    Boolean tenemosConexion=false;

    public RegistroPresenterImplement(RegistroView registroView, Context context){
        this.registroView = registroView;
        this.context = context;
        onCreate(registroView, context);
    }

    @Override
    public void onCreate(RegistroView registroView, Context context) {
        this.registroView = registroView;
        this.context = context;
    }

    @Override
    public void onDestroy() {
        registroView = null;
    }

    @Override
    public Boolean comprobarPasswords(String password, String passwordRepetido) {
        if(password.equals(passwordRepetido)){
            return true;
        }
        return false;
    }

    @Override
    public Boolean comprobarCampos(String usuario, String password, String passwordRepetido, String email) {
        if(!usuario.isEmpty() && !password.isEmpty() && !passwordRepetido.isEmpty() && !email.isEmpty()){
            return true;
        }
        return false;
    }

    @Override
    public Boolean comprobarMailValido(String email) {
        Pattern pattern;
        Matcher matcher;
        final String EMAIL_PATTERN = "^[_A-Za-z0-9-]+(\\.[_A-Za-z0-9-]+)*@[A-Za-z0-9]+(\\.[A-Za-z0-9]+)*(\\.[A-Za-z]{2,})$";
        pattern = Pattern.compile(EMAIL_PATTERN);
        matcher = pattern.matcher(email);
        return matcher.matches();
    }

    @Override
    public Boolean comprobarConexion() {

        try {
            tenemosConexion = CheckConexionInternet.tenemosConexion(context);
        } catch (MalformedURLException e) {
            e.printStackTrace();
        }

        return tenemosConexion;
    }
}
