package com.uoc.christian.bttroute.ResultadosActividad;

import dataUtils.DatosRuta;

/**
 * Created by christian on 23/10/17.
 */

public class ResultadosActivityPresenterImplement implements ResultadosActivityPresenter {

    private DatosRuta datosRuta;
    private ResultadosActivityView resultadosActivityView;

    public ResultadosActivityPresenterImplement(ResultadosActivityView resultadosActivityView, DatosRuta datosRuta){
        this.datosRuta = datosRuta;
        this.resultadosActivityView = resultadosActivityView;
        onCreate(resultadosActivityView, datosRuta);
    }

    @Override
    public void onCreate(ResultadosActivityView resultadosActivityView, DatosRuta datosRuta) {
        this.datosRuta = datosRuta;
        this.resultadosActivityView = resultadosActivityView;
    }

    @Override
    public void onDestroy() {
        datosRuta = null;
        resultadosActivityView = null;
    }

    @Override
    public String getTiempo() {
        return datosRuta.getTiempo();
    }

    @Override
    public String getDistancia() {
        return String.valueOf(datosRuta.getDistancia());
    }

    @Override
    public String getVelocidadMedia() {
        return String.valueOf(datosRuta.getVelocidadMedia());
    }

    @Override
    public String getVelocidadMaxima() {
        return String.valueOf(datosRuta.getVelocidadMaxima());
    }

    @Override
    public String getDesnivelPositivo() {
        return datosRuta.getDesnivelPositivo()!=null?String.valueOf(datosRuta.getDesnivelPositivo()):"0";
    }

    @Override
    public String getDesnivelNegativo() {

        return datosRuta.getDesnivelNegativo()!=null?String.valueOf(datosRuta.getDesnivelNegativo()):"0";
    }

    @Override
    public String getDesnivelAcumulado() {
        return datosRuta.getDesnivelAcumulado()!=null?String.valueOf(datosRuta.getDesnivelAcumulado()):"0";
    }
}
