package com.uoc.christian.bttroute.RutasServidorBusqueda;

import android.content.Context;

import com.example.christian.myapplication.backend.rutaApi.model.Ruta;
import dataUtils.DatosFiltros;
import dataUtils.DatosPosicion;
import dataUtils.ListasRutas;

import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.List;

import dataUtils.CheckConexionInternet;

/**
 * Created by christian on 21/11/17.
 */

public class RutasServidorPresenterImplement implements RutasServidorPresenter {

    private boolean tenemosConexion = true;
    Context context;

    public RutasServidorPresenterImplement(Context context){
        this.context = context;
        onCreate(context);
    }

    @Override
    public void onCreate(Context context) {
        this.context = context;
    }

    @Override
    public void onDestroy() {
        context = null;
    }

    @Override
    public void setListaRutasServidor(List<Ruta> rutas) {
        if(ListasRutas.listaRutasServ==null){
            ListasRutas.listaRutasServ = new ArrayList<>();
        }
        ListasRutas.listaRutasServ.addAll(rutas);
    }

    @Override
    public void setLocationUsuario(double latitude, double longitude) {
        DatosPosicion.latitudeInicial = latitude;
        DatosPosicion.longitudeInicial = longitude;
    }

    @Override
    public List<Ruta> getRutasServidor() {
        return ListasRutas.listaRutasServ;
    }

    @Override
    public double getLatitud() {
        return DatosPosicion.latitudeInicial;
    }

    @Override
    public double getLongitude() {
        return DatosPosicion.longitudeInicial;
    }

    @Override
    public boolean getIsFiltroAplicados() {
        return DatosFiltros.filtrosAplicados;
    }

    @Override
    public Boolean comprobarConexion() {

        try {
            tenemosConexion = CheckConexionInternet.tenemosConexion(context);
        } catch (MalformedURLException e) {
            e.printStackTrace();
        }

        return tenemosConexion;
    }
}
