package dataUtils;

import android.location.Location;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * Created by christian on 11/11/17.
 */

public class ExportToGPXFile {

    private ExportToGPXFile(){};

    public static Boolean crearGPXFile(File file, String n, List<Location> listaGeopoints, String idRuta, Long idUsuario) {
        //String TAG = GPX.class.getName();

        String header = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?><gpx xmlns=\"http://www.topografix.com/GPX/1/1\" creator=\"MapSource 6.15.5\" version=\"1.1\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"  xsi:schemaLocation=\"http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd\"><trk>\n";
        String name = "<name>" + n + "</name>";
        String usuario = "<linkUsuario>" + idUsuario + "</linkUsuario>";
        String rutaOrigen = "<linkRuta>" + idRuta + "</linkRuta><trkseg>\n";

        String segments = "";
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ssZ");
        for (Location l : listaGeopoints) {
            segments += "<trkpt lat=\"" + l.getLatitude() + "\" lon=\"" + l.getLongitude() + "\"><time>" + df.format(new Date(l.getTime())) + "</time></trkpt>\n";
        }

        String footer = "</trkseg></trk></gpx>";

        try {
            FileWriter writer = new FileWriter(file, false);
            writer.append(header);
            writer.append(name);
            writer.append(usuario);
            writer.append(rutaOrigen);
            writer.append(segments);
            writer.append(footer);
            writer.flush();
            writer.close();


            return true;

        } catch (IOException e) {
            return false;
        }
    }
}
