package com.example.christian.myapplication.backend;

import com.google.api.server.spi.config.Api;
import com.google.api.server.spi.config.ApiMethod;
import com.google.api.server.spi.config.ApiNamespace;
import com.google.api.server.spi.response.NotFoundException;
import com.googlecode.objectify.ObjectifyService;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.logging.Logger;

import javax.inject.Named;

import static com.googlecode.objectify.ObjectifyService.ofy;

/**
 * WARNING: This generated code is intended as a sample or starting point for using a
 * Google Cloud Endpoints RESTful API with an Objectify entity. It provides no data access
 * restrictions and no data validation.
 * <p>
 * DO NOT deploy this code unchanged as part of a real application to real users.
 */
@Api(
        name = "inicioRutasApi",
        version = "v1",
        resource = "inicioRutas",
        namespace = @ApiNamespace(
                ownerDomain = "backend.myapplication.christian.example.com",
                ownerName = "backend.myapplication.christian.example.com",
                packagePath = ""
        )
)
public class InicioRutasEndpoint {

    private static final Logger logger = Logger.getLogger(InicioRutasEndpoint.class.getName());

    private static final int DEFAULT_LIST_LIMIT = 20;

    static {
        // Typically you would register this inside an OfyServive wrapper. See: https://code.google.com/p/objectify-appengine/wiki/BestPractices
        ObjectifyService.register(InicioRutas.class);
    }

    @ApiMethod(
            name="get",
            path="idRuta",
            httpMethod = ApiMethod.HttpMethod.GET
    )
    public InicioRutas get(@Named("LatInicial")Double latInicial, @Named("LongInicial")Double longInicial){
        InicioRutas inicioRutas = null;
        Connection connection = null;

        try {
            Class.forName(Conexion.driver);
            connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
            String query = "SELECT * FROM InicioRutas WHERE LatInicial=" + latInicial + " AND LongInicial=" + longInicial;
            java.sql.ResultSet rs = connection.createStatement().executeQuery(query);

            if(rs!=null){
                while(rs.next()){
                    inicioRutas = new InicioRutas();
                    inicioRutas.setId(rs.getLong("Id"));
                    inicioRutas.setIdRuta(rs.getString("IdRuta"));
                    inicioRutas.setLatInicial(rs.getDouble("LatInicio"));
                    inicioRutas.setLongInicial(rs.getDouble("LongInicio"));
                }
            }
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        } finally {
            if(connection != null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }


        return inicioRutas;
    }

    /**
     * Inserts a new {@code InicioRutas}.
     */
    @ApiMethod(
            name = "insert",
            path = "inicioRutas",
            httpMethod = ApiMethod.HttpMethod.POST)
    public InicioRutas insert(InicioRutas inicioRutas) {
        Connection connection = null;
        PreparedStatement preparedStatement = null;
        InicioRutas iRutas = null;
        try {
            Class.forName(Conexion.driver);
            connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
            preparedStatement = connection.prepareStatement("INSERT INTO InicioRutas(IdRuta, LatInicial, LongInicial) VALUES(?,?,?);");
            preparedStatement.setString(1, inicioRutas.getIdRuta());
            preparedStatement.setDouble(2, inicioRutas.getLatInicial());
            preparedStatement.setDouble(3, inicioRutas.getLongInicial());;
            preparedStatement.execute();

            iRutas = inicioRutas;
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        } finally {
            if(connection != null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        return iRutas;
    }
}