package com.example.christian.myapplication.backend;

import com.google.api.server.spi.config.Api;
import com.google.api.server.spi.config.ApiCacheControl;
import com.google.api.server.spi.config.ApiMethod;
import com.google.api.server.spi.config.ApiNamespace;
import com.google.api.server.spi.response.NotFoundException;
import com.googlecode.objectify.ObjectifyService;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Types;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;

import javax.annotation.Nullable;
import javax.inject.Named;

import static com.googlecode.objectify.ObjectifyService.ofy;

/**
 * WARNING: This generated code is intended as a sample or starting point for using a
 * Google Cloud Endpoints RESTful API with an Objectify entity. It provides no data access
 * restrictions and no data validation.
 * <p>
 * DO NOT deploy this code unchanged as part of a real application to real users.
 */
@Api(
        name = "rutaApi",
        version = "v1",
        resource = "ruta",
        namespace = @ApiNamespace(
                ownerDomain = "backend.myapplication.christian.example.com",
                ownerName = "backend.myapplication.christian.example.com",
                packagePath = ""
        )
)
public class RutaEndpoint {

    private static final Logger logger = Logger.getLogger(RutaEndpoint.class.getName());

    private static final int DEFAULT_LIST_LIMIT = 4;

    static {
        // Typically you would register this inside an OfyServive wrapper. See: https://code.google.com/p/objectify-appengine/wiki/BestPractices
        ObjectifyService.register(Ruta.class);
    }

    /**
     * Returns the {@link Ruta} with the corresponding ID.
     *
     * @param IdFacebook the ID of the entity to be retrieved
     * @return the entity with the corresponding ID
     * @throws NotFoundException if there is no {@code Ruta} with the provided ID.
     */
    @ApiMethod(
            name = "getByIdFacebook",
            path = "rutaByIdFacebook/{UsuarioFacebook}",
            httpMethod = ApiMethod.HttpMethod.GET)
    public List<Ruta> getByIdFacebook(@Named("UsuarioFacebook") String IdFacebook, @Named("NextObjects")Integer nextObjects) throws NotFoundException {
        logger.info("Getting Rutas with ID: " + IdFacebook);
        List<Ruta> listaRutas = null;
        Connection connection = null;
        try {
            Class.forName(Conexion.driver);
            connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
            String query = "SELECT * FROM Ruta WHERE UsuarioFacebook=" + IdFacebook + " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
            java.sql.ResultSet rs = connection.createStatement().executeQuery(query);

            if(rs!=null){
                listaRutas = new ArrayList<Ruta>();
                while(rs.next()){
                    Ruta ruta = new Ruta();
                    ruta.setId(rs.getString("Id"));
                    ruta.setTituloRuta(rs.getString("TituloRuta"));
                    ruta.setIdUsuario(rs.getLong("IdUsuario"));
                    ruta.setCompartida(rs.getBoolean("Compartida"));
                    ruta.setUsuarioFacebook(rs.getString("UsuarioFacebook"));
                    ruta.setObservaciones(rs.getString("Observaciones"));
                    ruta.setIdDificultadTecnica(rs.getInt("IdDificultadTecnica"));
                    ruta.setIdDificultadFisica(rs.getInt("IdDificultadFisica"));
                    ruta.setTiempo(rs.getString("Tiempo"));
                    ruta.setDistancia(rs.getFloat("Distancia"));
                    ruta.setDesnivelPositivo(rs.getInt("DesnivelPositivo"));
                    ruta.setVelocidadMedia(rs.getFloat("VelocidadMedia"));
                    ruta.setVelocidadMaxima(rs.getFloat("VelocidadMaxima"));
                    ruta.setIdTipoRuta(rs.getInt("IdTipoRuta"));
                    ruta.setGeoPointsCodificados(rs.getString("GeoPointsCodificados"));
                    ruta.setIdRutaOriginal(rs.getString("IdRutaOriginal"));
                    ruta.setDesnivelNegativo(rs.getInt("DesnivelNegativo"));
                    ruta.setDesnivelAcumulado(rs.getInt("DesnivelAcumulado"));

                    listaRutas.add(ruta);
                }
            }
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        } finally {
            if(connection!=null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        return listaRutas;
    }

    /**
     * Returns the {@link Ruta} with the corresponding ID.
     *
     * @param IdUsuario the ID of the entity to be retrieved
     * @return the entity with the corresponding ID
     * @throws NotFoundException if there is no {@code Ruta} with the provided ID.
     */
    @ApiMethod(
            name = "getById",
            path = "rutaById/{IdUsuario}",
            httpMethod = ApiMethod.HttpMethod.GET)
    public List<Ruta> getById(@Named("IdUsuario") Long IdUsuario, @Named("NextObjects") Integer nextObjects) throws NotFoundException {
        logger.info("Getting Rutas with ID: " + IdUsuario);
        List<Ruta> listaRutas = null;
        Connection connection = null;
        try {
            Class.forName(Conexion.driver);
            connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
            String query = "SELECT * FROM Ruta WHERE IdUsuario=" + IdUsuario + " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
            java.sql.ResultSet rs = connection.createStatement().executeQuery(query);

            if(rs!=null){
                listaRutas = new ArrayList<Ruta>();
                while(rs.next()){
                    Ruta ruta = new Ruta();
                    ruta.setId(rs.getString("Id"));
                    ruta.setTituloRuta(rs.getString("TituloRuta"));
                    ruta.setIdUsuario(rs.getLong("IdUsuario"));
                    ruta.setCompartida(rs.getBoolean("Compartida"));
                    ruta.setUsuarioFacebook(rs.getString("UsuarioFacebook"));
                    ruta.setObservaciones(rs.getString("Observaciones"));
                    ruta.setIdDificultadTecnica(rs.getInt("IdDificultadTecnica"));
                    ruta.setIdDificultadFisica(rs.getInt("IdDificultadFisica"));
                    ruta.setTiempo(rs.getString("Tiempo"));
                    ruta.setDistancia(rs.getFloat("Distancia"));
                    ruta.setDesnivelPositivo(rs.getInt("DesnivelPositivo"));
                    ruta.setVelocidadMedia(rs.getFloat("VelocidadMedia"));
                    ruta.setVelocidadMaxima(rs.getFloat("VelocidadMaxima"));
                    ruta.setIdTipoRuta(rs.getInt("IdTipoRuta"));
                    ruta.setGeoPointsCodificados(rs.getString("GeoPointsCodificados"));
                    ruta.setIdRutaOriginal(rs.getString("IdRutaOriginal"));
                    ruta.setDesnivelNegativo(rs.getInt("DesnivelNegativo"));
                    ruta.setDesnivelAcumulado(rs.getInt("DesnivelAcumulado"));

                    listaRutas.add(ruta);
                }
            }
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        } finally {
            if(connection!=null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        return listaRutas;
    }

    /**
     * Inserts a new {@code Ruta}.
     */
    @ApiMethod(
            name = "insert",
            path = "ruta",
            httpMethod = ApiMethod.HttpMethod.POST)
    public Ruta insert(Ruta ruta) {
        // Typically in a RESTful API a POST does not have a known ID (assuming the ID is used in the resource path).
        // You should validate that ruta.Id has not been set. If the ID type is not supported by the
        // Objectify ID generator, e.g. long or String, then you should generate the unique ID yourself prior to saving.
        //
        // If your client provides the ID then you should probably use PUT instead.
        Connection connection = null;
        java.sql.PreparedStatement preparedStatement = null;

        try {
            Class.forName(Conexion.driver);
            connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
            preparedStatement = connection.prepareStatement("INSERT INTO Ruta(Id,TituloRuta,IdUsuario,Compartida,UsuarioFacebook,Observaciones,IdDificultadTecnica,IdDificultadFisica,Tiempo,Distancia, DesnivelPositivo,VelocidadMedia,VelocidadMaxima,IdTipoRuta,GeoPointsCodificados,IdRutaOriginal,DesnivelNegativo,DesnivelAcumulado)" +
                    " VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);");

            preparedStatement.setString(1,ruta.getId());
            preparedStatement.setString(2,ruta.getTituloRuta());
            if(ruta.getIdUsuario()!=null) {
                preparedStatement.setLong(3, ruta.getIdUsuario());
            }else{
                preparedStatement.setNull(3, Types.INTEGER);
            }
            preparedStatement.setBoolean(4, ruta.getCompartida());
            if(ruta.getUsuarioFacebook()!=null){
                preparedStatement.setString(5, ruta.getUsuarioFacebook()); //usuario facebook
            }else{
                preparedStatement.setNull(5, Types.NULL); //usuario facebook
            }
            preparedStatement.setString(6, ruta.getObservaciones());
            preparedStatement.setInt(7, ruta.getIdDificultadTecnica());
            preparedStatement.setInt(8, ruta.getIdDificultadFisica());
            preparedStatement.setString(9, ruta.getTiempo());
            preparedStatement.setFloat(10, ruta.getDistancia());
            preparedStatement.setInt(11, ruta.getDesnivelPositivo());
            preparedStatement.setFloat(12, ruta.getVelocidadMedia());
            preparedStatement.setFloat(13, ruta.getVelocidadMaxima());
            preparedStatement.setInt(14, ruta.getIdTipoRuta());
            preparedStatement.setString(15, ruta.getGeoPointsCodificados());
            preparedStatement.setString(16, ruta.getIdRutaOriginal());
            preparedStatement.setInt(17, ruta.getDesnivelNegativo());
            preparedStatement.setInt(18, ruta.getDesnivelAcumulado());
            preparedStatement.execute();


        } catch (ClassNotFoundException e) {
            ruta = null;
            e.printStackTrace();
        } catch (SQLException e) {
            ruta = null;
            e.printStackTrace();
        } finally {
            if(connection!=null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        logger.info("Created Ruta.");

        return ruta;
    }

    /**
     * Updates an existing {@code Ruta}.
     *
     * @return the updated version of the entity
     * @throws NotFoundException if the {ruta} does not correspond to an existing
     *                           {@code Ruta}
     */
    @ApiMethod(
            name = "update",
            path = "compartirRuta/Ruta",
            httpMethod = ApiMethod.HttpMethod.PUT)
    public Ruta update(Ruta ruta) throws NotFoundException {

        Connection connection=null;
        java.sql.PreparedStatement statement=null;

        try {
            Class.forName(Conexion.driver);
            connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
            statement = connection.prepareStatement("UPDATE Ruta SET Compartida="+true+" WHERE Id='"+ruta.getId()+"'");
            statement.executeUpdate();

        } catch (ClassNotFoundException e) {
            ruta = null;
            e.printStackTrace();
        } catch (SQLException e) {
            ruta = null;
            e.printStackTrace();
        } finally {
            if(connection!=null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        return ruta;
    }

    /**
     * Rutas que tienen su punto de inicio cerca a la loalización del usuario o ruta
     */
    @ApiMethod(
            name="getRutasByLocalizacionInicial",
            path="rutaByLocalizacionInicial",
            httpMethod = ApiMethod.HttpMethod.GET)
    public List<Ruta> getRutasByLocalizacion(@Named("Distancia") int distancia, @Named("LatInicial")Double latInicial, @Named("LongInicial")Double longInicial, @Named("NextObjects")Integer nextObjects, @Named("Paginacion")Boolean paginacion){

        Connection connection = null;
        List<Ruta> results = new ArrayList<>();

        try {
            Class.forName(Conexion.driver);
            connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
            String query = "";
            //En la lista de rutas que se muestra en el detalle de una ruta de servidor seleccionada, no se realiza paginación
            if(paginacion){
                query = "SELECT r.* FROM InicioRutas i " +
                    "INNER JOIN Ruta r on r.Id=i.IdRuta " +
                    "WHERE ST_Distance_Sphere(POINT(i.LatInicial,i.LongInicial), POINT("+latInicial + "," + longInicial +")) <= " + distancia +
                    " AND r.Compartida=1 LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
            } else {
                    query = "SELECT r.* FROM InicioRutas i " +
                        "INNER JOIN Ruta r on r.Id=i.IdRuta " +
                        "WHERE ST_Distance_Sphere(POINT(i.LatInicial,i.LongInicial), POINT("+latInicial + "," + longInicial +")) <= " + distancia +
                        " AND r.Compartida=1";
            }


            java.sql.ResultSet rs = connection.createStatement().executeQuery(query);

            if(rs!=null){
                while(rs.next()){
                    Ruta ruta = new Ruta();
                    ruta.setId(rs.getString("Id"));
                    ruta.setTituloRuta(rs.getString("TituloRuta"));
                    ruta.setIdUsuario(rs.getLong("IdUsuario"));
                    ruta.setCompartida(rs.getBoolean("Compartida"));
                    ruta.setUsuarioFacebook(rs.getString("UsuarioFacebook"));
                    ruta.setObservaciones(rs.getString("Observaciones"));
                    ruta.setIdDificultadTecnica(rs.getInt("IdDificultadTecnica"));
                    ruta.setIdDificultadFisica(rs.getInt("IdDificultadFisica"));
                    ruta.setTiempo(rs.getString("Tiempo"));
                    ruta.setDistancia(rs.getFloat("Distancia"));
                    ruta.setDesnivelPositivo(rs.getInt("DesnivelPositivo"));
                    ruta.setVelocidadMedia(rs.getFloat("VelocidadMedia"));
                    ruta.setVelocidadMaxima(rs.getFloat("VelocidadMaxima"));
                    ruta.setIdTipoRuta(rs.getInt("IdTipoRuta"));
                    ruta.setGeoPointsCodificados(rs.getString("GeoPointsCodificados"));
                    ruta.setIdRutaOriginal(rs.getString("IdRutaOriginal"));
                    ruta.setDesnivelNegativo(rs.getInt("DesnivelNegativo"));
                    ruta.setDesnivelAcumulado(rs.getInt("DesnivelAcumulado"));

                    results.add(ruta);
                }
            }
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        } finally {
            if(connection!=null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        return results;
    }

    /**
     * List all entities.
     *
     * @return a response that encapsulates the result list and the next page token/cursor
     */
    @ApiMethod(
            name = "getRutasByParametros",
            path = "ruta",
            httpMethod = ApiMethod.HttpMethod.GET)
    public List<Ruta> getRutasByParametros(@Named("Lugar")String lugar, @Named("Distancia") Integer distancia, @Named("DifFisica") long difFisica, @Named("DifTecnica") long difTecnica, @Named("TipoRuta") long tipoRuta, @Named("LatInicial")Double latInicial, @Named("LongInicial")Double longInicial, @Named("nextObjects")Integer nextObjects, @Named("PosicionInicio")Integer posicionInicio) {

        Connection connection = null;
        List<Ruta> results = new ArrayList<>();

        try {
            Class.forName(Conexion.driver);
            connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
            String query = "";

            if(lugar.isEmpty() || lugar.equals("")){
                if(difFisica!=0 && difTecnica!=0 && tipoRuta!=0) {
                    query = "SELECT r.* FROM InicioRutas i INNER JOIN Ruta r on r.Id=i.IdRuta" +
                            " WHERE r.Compartida=1 AND r.Distancia <=" + distancia +
                            " AND r.IdDificultadTecnica=" + difTecnica +
                            " AND r.IdDificultadFisica=" + difFisica +
                            " AND r.IdTipoRuta=" + tipoRuta +
                            " AND ST_Distance_Sphere(POINT(i.LatInicial,i.LongInicial), POINT("+latInicial + "," + longInicial +")) <= " + posicionInicio +
                            " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica!=0 && difTecnica!=0 && tipoRuta==0){
                    query = "SELECT r.* FROM InicioRutas i INNER JOIN Ruta r on r.Id=i.IdRuta" +
                            " WHERE r.Compartida=1 AND r.Distancia <=" + distancia +
                            " AND r.IdDificultadTecnica=" + difTecnica +
                            " AND r.IdDificultadFisica=" + difFisica +
                            " AND ST_Distance_Sphere(POINT(i.LatInicial,i.LongInicial), POINT("+latInicial + "," + longInicial +")) <= " + posicionInicio +
                            " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica!=0 && difTecnica==0 && tipoRuta==0){
                    query = "SELECT r.* FROM InicioRutas i INNER JOIN Ruta r on r.Id=i.IdRuta" +
                            " WHERE r.Compartida=1 AND r.Distancia <=" + distancia +
                            " AND ST_Distance_Sphere(POINT(i.LatInicial,i.LongInicial), POINT("+latInicial + "," + longInicial +")) <= " + posicionInicio +
                            " AND r.IdDificultadFisica=" + difFisica + " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica==0 && difTecnica==0 && tipoRuta==0){
                    query = "SELECT r.* FROM InicioRutas i INNER JOIN Ruta r on r.Id=i.IdRuta" +
                            " WHERE r.Compartida=1 AND r.Distancia <=" + distancia +
                            " AND ST_Distance_Sphere(POINT(i.LatInicial,i.LongInicial), POINT("+latInicial + "," + longInicial +")) <= " + posicionInicio +
                            " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica==0 && difTecnica==0 && tipoRuta!=0){
                    query = "SELECT r.* FROM InicioRutas i INNER JOIN Ruta r on r.Id=i.IdRuta" +
                            " WHERE Compartida=1 AND Distancia <=" + distancia +
                            " AND ST_Distance_Sphere(POINT(i.LatInicial,i.LongInicial), POINT("+latInicial + "," + longInicial +")) <= " + posicionInicio +
                            " AND IdTipoRuta=" + tipoRuta + " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica==0 && difTecnica!=0 && tipoRuta!=0){
                    query = "SELECT r.* FROM InicioRutas i INNER JOIN Ruta r on r.Id=i.IdRuta" +
                            " WHERE r.Compartida=1 AND r.Distancia <=" + distancia +
                            " AND r.IdDificultadTecnica=" + difTecnica +
                            " AND r.IdTipoRuta=" + tipoRuta +
                            " AND ST_Distance_Sphere(POINT(i.LatInicial,i.LongInicial), POINT("+latInicial + "," + longInicial +")) <= " + posicionInicio +
                            " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica==0 && difTecnica!=0 && tipoRuta==0){
                    query = "SELECT r.* FROM InicioRutas i INNER JOIN Ruta r on r.Id=i.IdRuta" +
                            " WHERE r.Compartida=1 AND r.Distancia <=" + distancia +
                            " AND r.IdDificultadTecnica=" + difTecnica +
                            " AND ST_Distance_Sphere(POINT(i.LatInicial,i.LongInicial), POINT("+latInicial + "," + longInicial +")) <= " + posicionInicio +
                            " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica!=0 && difTecnica==0 && tipoRuta!=0){
                    query = "SELECT r.* FROM InicioRutas i INNER JOIN Ruta r on r.Id=i.IdRuta" +
                            " WHERE r.Compartida=1 AND r.Distancia <=" + distancia +
                            " AND r.IdDificultadFisica=" + difFisica +
                            " AND r.IdTipoRuta=" + tipoRuta +
                            " AND ST_Distance_Sphere(POINT(i.LatInicial,i.LongInicial), POINT("+latInicial + "," + longInicial +")) <= " + posicionInicio +
                            " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }
            }else {
                if(difFisica!=0 && difTecnica!=0 && tipoRuta!=0) {
                    query = "SELECT * FROM Ruta WHERE TituloRuta like '%"+lugar+"%' AND Compartida=1 AND Distancia <=" + distancia + " AND IdDificultadTecnica=" + difTecnica + " AND IdDificultadFisica=" + difFisica + " AND IdTipoRuta=" + tipoRuta + " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica!=0 && difTecnica!=0 && tipoRuta==0){
                    query = "SELECT * FROM Ruta WHERE TituloRuta like '%"+lugar+"%' AND Compartida=1 AND Distancia <=" + distancia + " AND IdDificultadTecnica=" + difTecnica + " AND IdDificultadFisica=" + difFisica + " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica!=0 && difTecnica==0 && tipoRuta==0){
                    query = "SELECT * FROM Ruta WHERE TituloRuta like '%"+lugar+"%' AND Compartida=1 AND Distancia <=" + distancia + " AND IdDificultadFisica=" + difFisica + " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica==0 && difTecnica==0 && tipoRuta==0){
                    query = "SELECT * FROM Ruta WHERE TituloRuta like '%"+lugar+"%' AND Compartida=1 AND Distancia <=" + distancia + " LIMIT " + nextObjects + ",4";
                }else if(difFisica==0 && difTecnica==0 && tipoRuta!=0){
                    query = "SELECT * FROM Ruta WHERE TituloRuta like '%"+lugar+"%' AND Compartida=1 AND Distancia <=" + distancia + " AND IdTipoRuta=" + tipoRuta + " LIMIT " + nextObjects + ",4";
                }else if(difFisica==0 && difTecnica!=0 && tipoRuta!=0){
                    query = "SELECT * FROM Ruta WHERE TituloRuta like '%"+lugar+"%' AND Compartida=1 AND Distancia <=" + distancia + " AND IdDificultadTecnica=" + difTecnica + " AND IdTipoRuta=" + tipoRuta + " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica==0 && difTecnica!=0 && tipoRuta==0){
                    query = "SELECT * FROM Ruta WHERE TituloRuta like '%"+lugar+"%' AND Compartida=1 AND Distancia <=" + distancia + " AND IdDificultadTecnica=" + difTecnica + " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }else if(difFisica!=0 && difTecnica==0 && tipoRuta!=0){
                    query = "SELECT * FROM Ruta WHERE TituloRuta like '%"+lugar+"%' AND Compartida=1 AND Distancia <=" + distancia + " AND IdDificultadFisica=" + difFisica + " AND IdTipoRuta=" + tipoRuta + " LIMIT " + nextObjects + "," + DEFAULT_LIST_LIMIT;
                }
            }

            java.sql.ResultSet rs = connection.createStatement().executeQuery(query);

            if(rs!=null){
                while(rs.next()){
                    Ruta ruta = new Ruta();
                    ruta.setId(rs.getString("Id"));
                    ruta.setTituloRuta(rs.getString("TituloRuta"));
                    ruta.setIdUsuario(rs.getLong("IdUsuario"));
                    ruta.setCompartida(rs.getBoolean("Compartida"));
                    ruta.setUsuarioFacebook(rs.getString("UsuarioFacebook"));
                    ruta.setObservaciones(rs.getString("Observaciones"));
                    ruta.setIdDificultadTecnica(rs.getInt("IdDificultadTecnica"));
                    ruta.setIdDificultadFisica(rs.getInt("IdDificultadFisica"));
                    ruta.setTiempo(rs.getString("Tiempo"));
                    ruta.setDistancia(rs.getFloat("Distancia"));
                    ruta.setDesnivelPositivo(rs.getInt("DesnivelPositivo"));
                    ruta.setVelocidadMedia(rs.getFloat("VelocidadMedia"));
                    ruta.setVelocidadMaxima(rs.getFloat("VelocidadMaxima"));
                    ruta.setIdTipoRuta(rs.getInt("IdTipoRuta"));
                    ruta.setGeoPointsCodificados(rs.getString("GeoPointsCodificados"));
                    ruta.setIdRutaOriginal(rs.getString("IdRutaOriginal"));
                    ruta.setDesnivelNegativo(rs.getInt("DesnivelNegativo"));
                    ruta.setDesnivelAcumulado(rs.getInt("DesnivelAcumulado"));

                    results.add(ruta);
                }
            }

        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        } finally {
            if(connection!=null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        return results;
    }
}