package com.example.christian.myapplication.backend;

import com.google.api.server.spi.config.Api;
import com.google.api.server.spi.config.ApiMethod;
import com.google.api.server.spi.config.ApiNamespace;
import com.google.api.server.spi.response.CollectionResponse;
import com.google.api.server.spi.response.NotFoundException;
import com.google.appengine.api.datastore.Cursor;
import com.google.appengine.api.datastore.QueryResultIterator;
import java.sql.Connection;
import com.googlecode.objectify.ObjectifyService;
import com.googlecode.objectify.cmd.Query;

import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;

import javax.annotation.Nullable;
import javax.inject.Named;

import static com.googlecode.objectify.ObjectifyService.ofy;

/**
 * WARNING: This generated code is intended as a sample or starting point for using a
 * Google Cloud Endpoints RESTful API with an Objectify entity. It provides no data access
 * restrictions and no data validation.
 * <p>
 * DO NOT deploy this code unchanged as part of a real application to real users.
 */
@Api(
        name = "tipoRutaApi",
        version = "v1",
        resource = "tipoRuta",
        namespace = @ApiNamespace(
                ownerDomain = "backend.myapplication.christian.example.com",
                ownerName = "backend.myapplication.christian.example.com",
                packagePath = ""
        )
)
public class TipoRutaEndpoint {

    private static final Logger logger = Logger.getLogger(TipoRutaEndpoint.class.getName());

    private static final int DEFAULT_LIST_LIMIT = 20;

    static {
        // Typically you would register this inside an OfyServive wrapper. See: https://code.google.com/p/objectify-appengine/wiki/BestPractices
        ObjectifyService.register(TipoRuta.class);
    }

    /**
     * List all entities.
     * @return a response that encapsulates the result list and the next page token/cursor
     */
    @ApiMethod(
            name = "list",
            path = "tipoRuta",
            httpMethod = ApiMethod.HttpMethod.GET)
    public List<TipoRuta> list() {
        List<TipoRuta> tipoRutaList = new ArrayList<TipoRuta>(DEFAULT_LIST_LIMIT);
        Connection connection = null;

        try {
            Class.forName(Conexion.driver);
            connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
            String query = "SELECT * FROM TipoRuta;";
            java.sql.ResultSet rs = connection.createStatement().executeQuery(query);

            if(rs!=null){
                while(rs.next()){
                    TipoRuta tipoRuta = new TipoRuta();
                    tipoRuta.setId(rs.getLong("Id"));
                    tipoRuta.setDescripcion(rs.getString("Descripcion"));
                    tipoRutaList.add(tipoRuta);
                }
            }

        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }finally {
            if(connection != null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        return tipoRutaList;
    }
}