package com.example.christian.myapplication.backend;

import com.google.api.server.spi.config.Api;
import com.google.api.server.spi.config.ApiMethod;
import com.google.api.server.spi.config.ApiNamespace;
import com.google.api.server.spi.response.CollectionResponse;
import com.google.api.server.spi.response.NotFoundException;
import com.google.appengine.api.datastore.Cursor;
import com.google.appengine.api.datastore.QueryResultIterator;
import com.googlecode.objectify.ObjectifyService;
import com.googlecode.objectify.cmd.Query;

import java.sql.Connection;
import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;

import javax.annotation.Nullable;
import javax.inject.Named;

import static com.googlecode.objectify.ObjectifyService.ofy;

/**
 * WARNING: This generated code is intended as a sample or starting point for using a
 * Google Cloud Endpoints RESTful API with an Objectify entity. It provides no data access
 * restrictions and no data validation.
 * <p>
 * DO NOT deploy this code unchanged as part of a real application to real users.
 */
@Api(
        name = "usuarioApi",
        version = "v1",
        resource = "usuario",
        namespace = @ApiNamespace(
                ownerDomain = "backend.myapplication.christian.example.com",
                ownerName = "backend.myapplication.christian.example.com",
                packagePath = ""
        )
)
public class UsuarioEndpoint {

    private static final Logger logger = Logger.getLogger(UsuarioEndpoint.class.getName());

    private static final int DEFAULT_LIST_LIMIT = 20;

    static {
        // Typically you would register this inside an OfyServive wrapper. See: https://code.google.com/p/objectify-appengine/wiki/BestPractices
        ObjectifyService.register(Usuario.class);
    }

    /**
     * Returns the {@link Usuario} with the corresponding ID.
     *
     * @param user the user of the entity to be retrieved
     * @return the entity with the corresponding ID
     * @throws NotFoundException if there is no {@code Usuario} with the provided ID.
     */
    @ApiMethod(
            name = "get",
            path = "usuario/{Usuario}",
            httpMethod = ApiMethod.HttpMethod.GET)
    public Usuario get(@Named("Usuario") String user, @Named("Password") String password) throws NotFoundException {
        logger.info("Getting Usuario with Usuario: " + user);
        Usuario usuario = null;
        Connection connection = null;

        try {
            Class.forName(Conexion.driver);
            try {
                connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
                String query = "SELECT * FROM Usuarios WHERE Usuario = '" + user + "' AND Password = '" + password + "';";
                java.sql.ResultSet rs = connection.createStatement().executeQuery(query);

                if(rs!=null){
                    while(rs.next()){
                        usuario = new Usuario();
                        usuario.setId(rs.getLong("Id"));
                        usuario.setUser(rs.getString("Usuario"));
                        usuario.setEmail(rs.getString("Email"));
                        usuario.setPassword(rs.getString("Password"));
                    }
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } finally {
            if(connection != null){
                try {
                    connection.close(); // Cerramos conexión
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        return usuario;
    }

    /**
     * Inserts a new {@code Usuario}.
     */
    @ApiMethod(
            name = "insert",
            path = "usuario",
            httpMethod = ApiMethod.HttpMethod.POST)
    public Usuario insert(Usuario user) throws NotFoundException {
        // Typically in a RESTful API a POST does not have a known ID (assuming the ID is used in the resource path).
        // You should validate that usuario.Id has not been set. If the ID type is not supported by the
        // Objectify ID generator, e.g. long or String, then you should generate the unique ID yourself prior to saving.
        //
        // If your client provides the ID then you should probably use PUT instead.

        Usuario usuario = user;
        Connection connection = null;
        java.sql.PreparedStatement statement = null;

        try {
            Class.forName(Conexion.driver);
            try {
                connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);

                statement = connection.prepareStatement("INSERT INTO Usuarios(Usuario,Password,Email) VALUES (?,?,?);");

                statement.setString(1, user.getUser());
                statement.setString(2, user.getPassword());
                statement.setString(3, user.getEmail());

                statement.execute();

            } catch (SQLException e) {
                throw new NotFoundException("Error al crear usuario");
            }
        } catch (ClassNotFoundException e) {
            throw new NotFoundException("Error en insert");
        } finally {
            if(statement != null){
                try {
                    statement.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
            if(connection != null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        logger.info("Created Usuario.");

        return usuario;
    }

    @ApiMethod(
            name="updatePassword",
            path = "udpatePassword/{Usuario}",
            httpMethod = ApiMethod.HttpMethod.PUT
    )
    public Usuario updateClave(@Named("Usuario") String user, @Named("Password") String clave){
        Connection connection = null;
        java.sql.PreparedStatement statement = null;
        try {
            Class.forName(Conexion.driver);
            try {
                connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
                statement = connection.prepareStatement("UPDATE Usuarios SET Password='" + clave + "' WHERE Usuario='" + user + "';");
                statement.executeUpdate();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }finally {
            if(statement != null){
                try {
                    statement.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }

            if(connection != null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        return null;
    }

    /**
     * Comprobamos si existe algún usuario con el mismo nombre
     * @param user
     * @throws NotFoundException
     */
    @ApiMethod(
            name="checkExist",
            path="checkUsuario/{Usuario}",
            httpMethod = ApiMethod.HttpMethod.GET
    )
    public Usuario checkExists(@Named("Usuario") String user) throws NotFoundException {
        logger.info("Check if exists user: " + user);
        Connection connection = null;
        Usuario usuario = null;
        try {
            Class.forName(Conexion.driver);
            try {
                connection = DriverManager.getConnection(Conexion.url, Conexion.user, Conexion.password);
                String query = "SELECT * FROM Usuarios WHERE Usuario='" + user +"'";
                java.sql.ResultSet rs = connection.createStatement().executeQuery(query);

                if(rs != null){
                    while(rs.next()) {
                        usuario = new Usuario();
                        usuario.setUser(rs.getString("Usuario"));
                        usuario.setEmail(rs.getString("Email"));
                        usuario.setPassword(rs.getString("Password"));
                    }
                }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } finally {
            if(connection != null){
                try {
                    connection.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
            }
        }

        return usuario;
    }
}